[{"code":"require \"import\"\nimport \"android.widget.*\"\nimport \"android.view.*\"\nimport \"android.graphics.PixelFormat\"\nimport \"org.json.JSONObject\"\nimport \"android.content.Context\"\nimport \"android.content.Intent\"\nimport \"android.net.Uri\"\nimport \"android.util.TypedValue\"\n\n-- Function to get YouTube video information\nfunction getYouTubeInfo(url, callback)\n  local apiUrl = \"https:\/\/yt-vid.hazex.workers.dev\/?url=\" .. url\n  \n  Http.get(apiUrl, nil, function(code, content)\n    if code ~= 200 then\n      callback(nil, \"Error fetching video information\")\n    else\n      local json = require \"cjson\"\n      local response = json.decode(content)\n      callback(response)\n    end\n  end)\nend\n\n-- Create main layout\nlocal layout = {\n  LinearLayout,\n  orientation = \"vertical\",\n  layout_width = \"match_parent\",\n  layout_height = \"match_parent\",\n  padding = \"16dp\",\n  backgroundColor = \"#FFFFFF\",\n  {\n    EditText,\n    id = \"urlInput\",\n    hint = \"Enter YouTube URL\",\n    layout_width = \"match_parent\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n  },\n  {\n    Button,\n    id = \"fetchButton\",\n    text = \"Fetch Video Info\",\n    layout_width = \"wrap_content\",\n    layout_height = \"wrap_content\",\n  },\n  {\n    ScrollView,\n    layout_width = \"match_parent\",\n    layout_height = \"match_parent\",\n    {\n      TextView,\n      id = \"responseDisplay\",\n      text = \"\",\n      layout_width = \"wrap_content\",\n      layout_height = \"wrap_content\",\n      padding = \"10dp\",\n    }\n  },\n  {\n    Button,\n    id = \"closeButton\",\n    text = \"Close\",\n    layout_width = \"wrap_content\",\n    layout_height = \"wrap_content\",\n  }\n}\n\n-- Create and show floating window\nlocal windowManager = service.getSystemService(Context.WINDOW_SERVICE)\nlocal params = WindowManager.LayoutParams()\nparams.type = WindowManager.LayoutParams.TYPE_ACCESSIBILITY_OVERLAY\nparams.format = PixelFormat.TRANSLUCENT\nparams.flags = WindowManager.LayoutParams.FLAG_NOT_FOCUSABLE\nparams.width = WindowManager.LayoutParams.WRAP_CONTENT\nparams.height = WindowManager.LayoutParams.WRAP_CONTENT\nparams.gravity = Gravity.TOP | Gravity.LEFT\n\nlocal view = loadlayout(layout)\nwindowManager.addView(view, params)\n\n-- Function to format video info\nfunction formatVideoInfo(info)\n  local result = string.format(\n    \"Title: %s\\nDuration: %d seconds\\nViews: %d\\nUploader: %s\\nThumbnail: %s\\n\\n\",\n    info.title, info.duration, info.view_count, info.uploader, info.thumbnail\n  )\n  \n  result = result .. \"Video Links:\\n\"\n  for _, video in ipairs(info.video) do\n    result = result .. string.format(\"- %s: %s\\n\", video.video_format, video.url)\n  end\n  \n  result = result .. \"\\nAudio Links:\\n\"\n  for _, audio in ipairs(info.audio) do\n    result = result .. string.format(\"- %s: %s\\n\", audio.audio_format, audio.url)\n  end\n  \n  return result\nend\n\n-- Set up fetch button\nfetchButton.onClick = function()\n  local url = urlInput.text\n  if url and url ~= \"\" then\n    getYouTubeInfo(url, function(videoInfo, error)\n      if error then\n        responseDisplay.text = \"Error: \" .. error\n      else\n        responseDisplay.text = formatVideoInfo(videoInfo)\n      end\n    end)\n  else\n    Toast.makeText(service, \"Please enter a YouTube URL\", Toast.LENGTH_SHORT).show()\n  end\nend\n\n-- Set up close button\ncloseButton.onClick = function()\n  windowManager.removeView(view)\nend\n\n-- Add credit\nlocal creditText = TextView(service)\ncreditText.setText(\"Temporary Email API by @jcftbs\")\ncreditText.setTextSize(TypedValue.COMPLEX_UNIT_SP, 10)\ncreditText.setPadding(10, 10, 10, 10)  -- Left, Top, Right, Bottom padding in pixels\nview.addView(creditText)"},{"code":"require \"import\"\nimport \"android.widget.*\"\nimport \"android.view.*\"\nimport \"android.app.*\"\nimport \"java.util.*\"\nimport \"android.content.*\"\nimport \"android.speech.tts.TextToSpeech\"\nimport \"android.speech.SpeechRecognizer\"\nimport \"android.speech.RecognizerIntent\"\nimport \"com.loopj.android.http.*\"\nimport \"cjson\"\nimport \"android.Manifest\"\nimport \"android.content.pm.PackageManager\"\nimport \"android.os.Vibrator\"\nimport \"android.content.ClipboardManager\"\nimport \"android.content.ClipData\"\nimport \"android.text.InputType\"\n\nlocal activity = activity\nlocal VERSION = \"1.3.1\"\nlocal tts\nlocal speechRecognizer\nlocal isListening = false\nlocal CONVERSATIONS_FILE = \"\/storage\/emulated\/0\/AI-Phone\/ai_phone_conversations.txt\"\nlocal vibrator\nlocal codeButton\nlocal codeDialog\nlocal generatedCodeCount = 0\nlocal generatedCodes = {}\nlocal currentConversation = {gpt = {}, user = {}}\n\nfunction createRecognitionListener()\n    return {\n        onResults = function(results)\n            local matches = results.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)\n            if matches and matches.size() > 0 then\n                local recognizedText = matches.get(0)\n                askChatGPT(recognizedText)\n            else\n                speak(\"I didn't understand that. Please try again.\")\n                vibrate(200)\n            end\n            isListening = false\n        end,\n        onError = function(error)\n            speak(\"Error in speech recognition. Please try again.\")\n            vibrate(500)\n            isListening = false\n        end,\n        onReadyForSpeech = function(params)\n            speak(\"I'm listening\")\n            vibrate(100)\n        end,\n        onEndOfSpeech = function()\n            isListening = false\n        end\n    }\nend\n\nfunction initialGreeting()\n    speak(\"Welcome to AI Phone. Touch the screen to start or stop voice input. Chat logs are saved in internal storage.\")\n    vibrate(500)\nend\n\nfunction onCreate(savedInstanceState)\n    activity.setTitle(\"AI Phone v\" .. VERSION)\n    local layout = LinearLayout(activity)\n    layout.setOrientation(LinearLayout.VERTICAL)\n    \n    local storageInfo = TextView(activity)\n    storageInfo.setText(\"Chat logs are saved in internal storage: \" .. CONVERSATIONS_FILE)\n    layout.addView(storageInfo)\n    \n    tts = TextToSpeech(activity, TextToSpeech.OnInitListener({\n        onInit = function(status)\n            if status == TextToSpeech.SUCCESS then\n                tts.setLanguage(Locale.US)\n                initialGreeting()\n            else\n                speak(\"Text-to-speech initialization failed.\")\n            end\n        end\n    }))\n    \n    if SpeechRecognizer.isRecognitionAvailable(activity) then\n        speechRecognizer = SpeechRecognizer.createSpeechRecognizer(activity)\n        speechRecognizer.setRecognitionListener(createRecognitionListener())\n    else\n        speak(\"Speech recognition is not available on this device.\")\n    end\n    \n    vibrator = activity.getSystemService(Context.VIBRATOR_SERVICE)\n    \n    local talkButton = Button(activity)\n    talkButton.setText(\"Talk to AI\")\n    talkButton.setOnClickListener{\n        onClick = function()\n            if isListening then\n                stopListening()\n            else\n                startListening()\n            end\n        end\n    }\n    layout.addView(talkButton)\n    \n    codeButton = Button(activity)\n    updateCodeButtonText()\n    codeButton.setOnClickListener{\n        onClick = function()\n            showCodeNumberDialog()\n        end\n    }\n    layout.addView(codeButton)\n    \n    local resetButton = Button(activity)\n    resetButton.setText(\"Reset Conversation\")\n    resetButton.setOnClickListener{\n        onClick = function()\n            resetConversation()\n        end\n    }\n    layout.addView(resetButton)\n    \n    activity.setContentView(layout)\n    \n    requestPermissions()\n    ensureConversationFileExists()\nend\n\nfunction updateCodeButtonText()\n    codeButton.setText(\"Code (\" .. generatedCodeCount .. \")\")\nend\n\nfunction ensureConversationFileExists()\n    local path = CONVERSATIONS_FILE\n    local file = io.open(path, \"a+\")\n    if file then\n        file:close()\n    else\n        print(\"Error: Cannot open or create file for writing\")\n    end\nend\n\nfunction requestPermissions()\n    local permissions = {\n        Manifest.permission.RECORD_AUDIO,\n        Manifest.permission.WRITE_EXTERNAL_STORAGE,\n        Manifest.permission.VIBRATE\n    }\n    activity.requestPermissions(permissions, 1)\nend\n\nfunction onRequestPermissionsResult(requestCode, permissions, grantResults)\n    if requestCode == 1 then\n        if grantResults[1] == PackageManager.PERMISSION_GRANTED and\n            grantResults[2] == PackageManager.PERMISSION_GRANTED and\n            grantResults[3] == PackageManager.PERMISSION_GRANTED then\n            speak(\"Permissions granted. You can now use voice input and vibration.\")\n        else\n            speak(\"Permissions denied. Some features may not work.\")\n        end\n    end\nend\n\nfunction startListening()\n    if not isListening then\n        local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)\n        intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)\n        intent.putExtra(RecognizerIntent.EXTRA_PARTIAL_RESULTS, false)\n        speechRecognizer.startListening(intent)\n        isListening = true\n    else\n        speak(\"I'm already listening\")\n        vibrate(200)\n    end\nend\n\nfunction stopListening()\n    if isListening then\n        speechRecognizer.stopListening()\n        isListening = false\n        speak(\"Stopped listening\")\n        vibrate(300)\n    end\nend\n\nfunction askChatGPT(question)\n    speak(\"You said: \" .. question)\n    vibrate(100)\n    \n    table.insert(currentConversation.user, question)\n    \n    local url = \"https:\/\/chat-gpt.hazex.workers.dev\/\"\n    local requestBody = {\n        gpt = currentConversation.gpt,\n        user = question\n    }\n    \n    local jsonBody = cjson.encode(requestBody)\n    \n    Http.post(url, jsonBody, \"application\/json\", function(code, content)\n        if code == 200 then\n            local response = cjson.decode(content)\n            if response and response.answer then\n                local answer = response.answer\n                speak(\"AI response: \" .. answer)\n                vibrate(200)\n                saveConversation(question, answer)\n                \n                table.insert(currentConversation.gpt, answer)\n                \n                local codeSnippets = extractCodeSnippets(answer)\n                for _, snippet in ipairs(codeSnippets) do\n                    generatedCodeCount = generatedCodeCount + 1\n                    table.insert(generatedCodes, snippet)\n                    updateCodeButtonText()\n                end\n            else\n                speak(\"Received an unexpected response format.\")\n                vibrate(500)\n            end\n        else\n            speak(\"An error occurred while processing the request.\")\n            vibrate(500)\n        end\n    end)\nend\n\nfunction resetConversation()\n    currentConversation = {gpt = {}, user = {}}\n    speak(\"Conversation history has been reset.\")\n    vibrate(300)\nend\n\nfunction extractCodeSnippets(text)\n    local snippets = {}\n    for snippet in text:gmatch(\"```(.-)```\") do\n        table.insert(snippets, snippet)\n    end\n    return snippets\nend\n\nfunction saveConversation(question, answer)\n    local path = CONVERSATIONS_FILE\n    local file = io.open(path, \"a+\")\n    if file then\n        file:write(string.format(\"Q: %s\\nA: %s\\n\\n\", tostring(question), tostring(answer)))\n        file:close()\n    else\n        print(\"Error: Cannot open or create file for writing\")\n    end\nend\n\nfunction speak(text)\n    tts.speak(text, TextToSpeech.QUEUE_FLUSH, nil)\nend\n\nfunction vibrate(duration)\n    vibrator.vibrate(duration)\nend\n\nfunction urlEncode(text)\n    text = tostring(text)\n    text = text:gsub(\"\\n\", \"\\r\\n\")\n    text = text:gsub(\"([^%w %-%_%.%~])\", function(c)\n        return string.format(\"%%%02X\", string.byte(c))\n    end)\n    text = text:gsub(\" \", \"+\")\n    return text\nend\n\nfunction cleanText(text)\n    local cleanedText = cjson.decode(text)\n    \n    if cleanedText then\n        cleanedText = cleanedText.answer\n        return cleanedText\n    else\n        return \"The text is not available.\"\n    end\nend\n\nfunction showCodeNumberDialog()\n    if generatedCodeCount == 0 then\n        speak(\"No code has been generated yet.\")\n        return\n    end\n\n    local builder = AlertDialog.Builder(activity)\n    builder.setTitle(\"Generated Code Numbers\")\n\n    local message = \"Total code snippets generated: \" .. generatedCodeCount .. \"\\n\\n\"\n    for i, code in ipairs(generatedCodes) do\n        message = message .. \"Code #\" .. i .. \"\\n\"\n    end\n\n    builder.setMessage(message)\n\n    builder.setPositiveButton(\"Close\", nil)\n\n    builder.setNeutralButton(\"Show\", {\n        onClick = function()\n            showFullCode()\n        end\n    })\n\n    builder.setNegativeButton(\"Save\", {\n        onClick = function()\n            promptForCodeNumberToSave()\n        end\n    })\n\n    codeDialog = builder.create()\n    codeDialog.show()\n\n    -- Add Copy button\n    local copyButton = codeDialog.getButton(DialogInterface.BUTTON_NEUTRAL)\n    copyButton.setText(\"Copy\")\n    copyButton.setOnClickListener{\n        onClick = function()\n            copyAllCode()\n        end\n    }\n\n    -- Add Show button\n    local showButton = Button(activity)\n    showButton.setText(\"Show\")\n    showButton.setOnClickListener{\n        onClick = function()\n            showFullCode()\n        end\n    }\n    codeDialog.addContentView(showButton, LinearLayout.LayoutParams(LinearLayout.LayoutParams.WRAP_CONTENT, LinearLayout.LayoutParams.WRAP_CONTENT))\nend\n\nfunction showFullCode()\n    local allCode = \"\"\n    for i, code in ipairs(generatedCodes) do\n        allCode = allCode .. \"Code #\" .. i .. \":\\n\" .. code .. \"\\n\\n\"\n    end\n\n    local builder = AlertDialog.Builder(activity)\n    builder.setTitle(\"All Generated Code\")\n    builder.setMessage(allCode)\n    builder.setPositiveButton(\"Close\", nil)\n    builder.show()\nend\n\nfunction copyAllCode()\n    local allCode = \"\"\n    for i, code in ipairs(generatedCodes) do\n        allCode = allCode .. \"Code #\" .. i .. \":\\n\" .. code .. \"\\n\\n\"\n    end\n\n    local clipboard = activity.getSystemService(Context.CLIPBOARD_SERVICE)\n    local clip = ClipData.newPlainText(\"Generated Code\", allCode)\n    clipboard.setPrimaryClip(clip)\n    speak(\"All code copied to clipboard\")\nend\n\nfunction promptForCodeNumberToSave()\n    local builder = AlertDialog.Builder(activity)\n    builder.setTitle(\"Save Code\")\n    builder.setMessage(\"Enter the number of the code snippet you want to save:\")\n\n    local input = EditText(activity)\n    input.setInputType(InputType.TYPE_CLASS_NUMBER)\n    builder.setView(input)\n\n    builder.setPositiveButton(\"Save\", {\n        onClick = function()\n            local codeNumber = tonumber(input.getText().toString())\n            if codeNumber then\n                saveCodeToFile(codeNumber)\n            else\n                speak(\"Invalid input. Please enter a number.\")\n            end\n        end\n    })\n\n    builder.setNegativeButton(\"Cancel\", nil)\n\n    local dialog = builder.create()\n    dialog.show()\nend\n\nfunction saveCodeToFile(codeNumber)\n    if codeNumber > 0 and codeNumber <= generatedCodeCount then\n        local fileName = \"generated_code_\" .. codeNumber .. \".txt\"\n        local path = \"\/storage\/emulated\/0\/AI-Phone\/\" .. fileName\n        \n        local file = io.open(path, \"w\")\n        if file then\n            file:write(generatedCodes[codeNumber])\n            file:close()\n            speak(\"Code number \" .. codeNumber .. \" saved as \" .. fileName)\n        else\n            speak(\"Error saving code to file\")\n        end\n    else\n        speak(\"Invalid code number\")\n    end\nend"},{"code":"require \"import\"\nimport \"android.widget.*\"\nimport \"android.view.*\"\nimport \"android.app.*\"\nimport \"java.util.*\"\nimport \"android.content.*\"\nimport \"android.speech.tts.TextToSpeech\"\nimport \"android.speech.SpeechRecognizer\"\nimport \"android.speech.RecognizerIntent\"\nimport \"com.loopj.android.http.*\"\nimport \"cjson\"\nimport \"android.Manifest\"\nimport \"android.content.pm.PackageManager\"\nimport \"android.os.Vibrator\"\nimport \"android.content.ClipboardManager\"\nimport \"android.content.ClipData\"\nimport \"android.text.InputType\"\n\nlocal activity = activity\nlocal VERSION = \"1.3.3\"\nlocal tts\nlocal speechRecognizer\nlocal isListening = false\nlocal CONVERSATIONS_FILE = \"\/storage\/emulated\/0\/AI-Phone\/ai_phone_conversations.txt\"\nlocal vibrator\nlocal codeButton\nlocal codeDialog\nlocal generatedCodeCount = 0\nlocal generatedCodes = {}\nlocal currentConversation = {gpt = {}, user = {}}\n\nfunction createRecognitionListener()\n    return {\n        onResults = function(results)\n            local matches = results.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)\n            if matches and matches.size() > 0 then\n                local recognizedText = matches.get(0)\n                askChatGPT(recognizedText)\n            else\n                speak(\"I didn't understand that. Please try again.\")\n                vibrate(200)\n            end\n            isListening = false\n        end,\n        onError = function(error)\n            speak(\"Error in speech recognition. Please try again.\")\n            vibrate(500)\n            isListening = false\n        end,\n        onReadyForSpeech = function(params)\n            speak(\"I'm listening\")\n            vibrate(100)\n        end,\n        onEndOfSpeech = function()\n            isListening = false\n        end\n    }\nend\n\nfunction initialGreeting()\n    speak(\"Welcome to AI Phone. Touch the screen to start or stop voice input. Chat logs are saved in internal storage.\")\n    vibrate(500)\nend\n\nfunction onCreate(savedInstanceState)\n    activity.setTitle(\"AI Phone v\" .. VERSION)\n    local layout = LinearLayout(activity)\n    layout.setOrientation(LinearLayout.VERTICAL)\n    \n    local storageInfo = TextView(activity)\n    storageInfo.setText(\"Chat logs are saved in internal storage: \" .. CONVERSATIONS_FILE)\n    layout.addView(storageInfo)\n    \n    tts = TextToSpeech(activity, TextToSpeech.OnInitListener({\n        onInit = function(status)\n            if status == TextToSpeech.SUCCESS then\n                tts.setLanguage(Locale.US)\n                initialGreeting()\n            else\n                speak(\"Text-to-speech initialization failed.\")\n            end\n        end\n    }))\n    \n    if SpeechRecognizer.isRecognitionAvailable(activity) then\n        speechRecognizer = SpeechRecognizer.createSpeechRecognizer(activity)\n        speechRecognizer.setRecognitionListener(createRecognitionListener())\n    else\n        speak(\"Speech recognition is not available on this device.\")\n    end\n    \n    vibrator = activity.getSystemService(Context.VIBRATOR_SERVICE)\n    \n    local talkButton = Button(activity)\n    talkButton.setText(\"Talk to AI\")\n    talkButton.setOnClickListener{\n        onClick = function()\n            if isListening then\n                stopListening()\n            else\n                startListening()\n            end\n        end\n    }\n    layout.addView(talkButton)\n    \n    codeButton = Button(activity)\n    updateCodeButtonText()\n    codeButton.setOnClickListener{\n        onClick = function()\n            showCodeNumberDialog()\n        end\n    }\n    layout.addView(codeButton)\n    \n    local resetButton = Button(activity)\n    resetButton.setText(\"Reset Conversation\")\n    resetButton.setOnClickListener{\n        onClick = function()\n            resetConversation()\n        end\n    }\n    layout.addView(resetButton)\n    \n    activity.setContentView(layout)\n    \n    requestPermissions()\n    ensureConversationFileExists()\nend\n\nfunction updateCodeButtonText()\n    codeButton.setText(\"Code (\" .. generatedCodeCount .. \")\")\nend\n\nfunction ensureConversationFileExists()\n    local path = CONVERSATIONS_FILE\n    local file = io.open(path, \"a+\")\n    if file then\n        file:close()\n    else\n        print(\"Error: Cannot open or create file for writing\")\n    end\nend\n\nfunction requestPermissions()\n    local permissions = {\n        Manifest.permission.RECORD_AUDIO,\n        Manifest.permission.WRITE_EXTERNAL_STORAGE,\n        Manifest.permission.VIBRATE\n    }\n    activity.requestPermissions(permissions, 1)\nend\n\nfunction onRequestPermissionsResult(requestCode, permissions, grantResults)\n    if requestCode == 1 then\n        if grantResults[1] == PackageManager.PERMISSION_GRANTED and\n            grantResults[2] == PackageManager.PERMISSION_GRANTED and\n            grantResults[3] == PackageManager.PERMISSION_GRANTED then\n            speak(\"Permissions granted. You can now use voice input and vibration.\")\n        else\n            speak(\"Permissions denied. Some features may not work.\")\n        end\n    end\nend\n\nfunction startListening()\n    if not isListening then\n        local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)\n        intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)\n        intent.putExtra(RecognizerIntent.EXTRA_PARTIAL_RESULTS, false)\n        speechRecognizer.startListening(intent)\n        isListening = true\n    else\n        speak(\"I'm already listening\")\n        vibrate(200)\n    end\nend\n\nfunction stopListening()\n    if isListening then\n        speechRecognizer.stopListening()\n        isListening = false\n        speak(\"Stopped listening\")\n        vibrate(300)\n    end\nend\n\nfunction askChatGPT(question)\n    speak(\"You said: \" .. question)\n    vibrate(100)\n    \n    table.insert(currentConversation.user, question)\n    \n    local url = \"https:\/\/chat-gpt.hazex.workers.dev\/\"\n    local requestBody = {\n        gpt = currentConversation.gpt,\n        user = question\n    }\n    \n    local jsonBody = cjson.encode(requestBody)\n    \n    Http.post(url, jsonBody, \"application\/json\", function(code, content)\n        if code == 200 then\n            local response = cjson.decode(content)\n            if response and response.answer then\n                local answer = response.answer\n                speak(\"AI response: \" .. answer)\n                vibrate(200)\n                saveConversation(question, answer)\n                \n                table.insert(currentConversation.gpt, answer)\n                \n                local codeSnippets = extractCodeSnippets(answer)\n                for _, snippet in ipairs(codeSnippets) do\n                    generatedCodeCount = generatedCodeCount + 1\n                    table.insert(generatedCodes, snippet)\n                    updateCodeButtonText()\n                end\n            else\n                speak(\"Received an unexpected response format.\")\n                vibrate(500)\n            end\n        else\n            speak(\"An error occurred while processing the request.\")\n            vibrate(500)\n        end\n    end)\nend\n\nfunction resetConversation()\n    currentConversation = {gpt = {}, user = {}}\n    speak(\"Conversation history has been reset.\")\n    vibrate(300)\nend\n\nfunction extractCodeSnippets(text)\n    local snippets = {}\n    for snippet in text:gmatch(\"```(.-)```\") do\n        table.insert(snippets, snippet)\n    end\n    return snippets\nend\n\nfunction saveConversation(question, answer)\n    local path = CONVERSATIONS_FILE\n    local file = io.open(path, \"a+\")\n    if file then\n        file:write(string.format(\"Q: %s\\nA: %s\\n\\n\", tostring(question), tostring(answer)))\n        file:close()\n    else\n        print(\"Error: Cannot open or create file for writing\")\n    end\nend\n\nfunction speak(text)\n    tts.speak(text, TextToSpeech.QUEUE_FLUSH, nil)\nend\n\nfunction vibrate(duration)\n    vibrator.vibrate(duration)\nend\n\nfunction urlEncode(text)\n    text = tostring(text)\n    text = text:gsub(\"\\n\", \"\\r\\n\")\n    text = text:gsub(\"([^%w %-%_%.%~])\", function(c)\n        return string.format(\"%%%02X\", string.byte(c))\n    end)\n    text = text:gsub(\" \", \"+\")\n    return text\nend\n\nfunction cleanText(text)\n    local cleanedText = cjson.decode(text)\n    \n    if cleanedText then\n        cleanedText = cleanedText.answer\n        return cleanedText\n    else\n        return \"The text is not available.\"\n    end\nend\n\nfunction showCodeNumberDialog()\n    if generatedCodeCount == 0 then\n        speak(\"No code has been generated yet.\")\n        return\n    end\n\n    local builder = AlertDialog.Builder(activity)\n    builder.setTitle(\"Generated Code Numbers\")\n\n    local message = \"Total code snippets generated: \" .. generatedCodeCount .. \"\\n\\n\"\n    for i, code in ipairs(generatedCodes) do\n        message = message .. \"Code #\" .. i .. \"\\n\"\n    end\n\n    builder.setMessage(message)\n\n    builder.setPositiveButton(\"Close\", nil)\n\n    builder.setNeutralButton(\"Show\", {\n        onClick = function()\n            showFullCode()\n        end\n    })\n\n    builder.setNegativeButton(\"Save\", {\n        onClick = function()\n            promptForCodeNumberToSave()\n        end\n    })\n\n    codeDialog = builder.create()\n    codeDialog.show()\n\n    -- Add Copy button\n    local copyButton = codeDialog.getButton(DialogInterface.BUTTON_NEUTRAL)\n    copyButton.setText(\"Copy\")\n    copyButton.setOnClickListener{\n        onClick = function()\n            copyAllCode()\n        end\n    }\n\n    -- Add Show button\n    local showButton = Button(activity)\n    showButton.setText(\"Show\")\n    showButton.setOnClickListener{\n        onClick = function()\n            showFullCode()\n        end\n    }\n    codeDialog.addContentView(showButton, LinearLayout.LayoutParams(LinearLayout.LayoutParams.WRAP_CONTENT, LinearLayout.LayoutParams.WRAP_CONTENT))\nend\n\nfunction showFullCode()\n    local allCode = \"\"\n    for i, code in ipairs(generatedCodes) do\n        allCode = allCode .. \"Code #\" .. i .. \":\\n\" .. code .. \"\\n\\n\"\n    end\n\n    local builder = AlertDialog.Builder(activity)\n    builder.setTitle(\"All Generated Code\")\n    builder.setMessage(allCode)\n    builder.setPositiveButton(\"Close\", nil)\n    builder.show()\nend\n\nfunction copyAllCode()\n    local allCode = \"\"\n    for i, code in ipairs(generatedCodes) do\n        allCode = allCode .. \"Code #\" .. i .. \":\\n\" .. code .. \"\\n\\n\"\n    end\n\n    local clipboard = activity.getSystemService(Context.CLIPBOARD_SERVICE)\n    local clip = ClipData.newPlainText(\"Generated Code\", allCode)\n    clipboard.setPrimaryClip(clip)\n    speak(\"All code copied to clipboard\")\nend\n\nfunction promptForCodeNumberToSave()\n    local builder = AlertDialog.Builder(activity)\n    builder.setTitle(\"Save Code\")\n    builder.setMessage(\"Enter the number of the code snippet you want to save:\")\n\n    local input = EditText(activity)\n    input.setInputType(InputType.TYPE_CLASS_NUMBER)\n    builder.setView(input)\n\n    builder.setPositiveButton(\"Save\", {\n        onClick = function()\n            local codeNumber = tonumber(input.getText().toString())\n            if codeNumber then\n                saveCodeToFile(codeNumber)\n            else\n                speak(\"Invalid input. Please enter a number.\")\n            end\n        end\n    })\n\n    builder.setNegativeButton(\"Cancel\", nil)\n\n    local dialog = builder.create()\n    dialog.show()\nend\n\nfunction saveCodeToFile(codeNumber)\n    if codeNumber > 0 and codeNumber <= generatedCodeCount then\n        local fileName = \"generated_code_\" .. codeNumber .. \".txt\"\n        local path = \"\/storage\/emulated\/0\/AI-Phone\/\" .. fileName\n        \n        local file = io.open(path, \"w\")\n        if file then\n            file:write(generatedCodes[codeNumber])\n            file:close()\n            speak(\"Code number \" .. codeNumber .. \" saved as \" .. fileName)\n        else\n            speak(\"Error saving code to file\")\n        end\n    else\n        speak(\"Invalid code number\")\n    end\nend"},{"code":"require \"import\"\nimport \"android.widget.*\"\nimport \"android.view.*\"\nimport \"android.net.Uri\"\nimport \"android.content.Context\"\nimport \"android.app.DownloadManager\"\nimport \"android.os.Environment\"\nimport \"android.graphics.PixelFormat\"\nimport \"android.content.ClipboardManager\"\n\n-- Function to generate logo\nfunction generateLogo(businessDescription, businessName, slogan, colors, tags, callback)\n  local apiUrl = \"https:\/\/steel-plant-report.glitch.me\/api\/logo\/\" .. businessDescription .. \"\/\" .. businessName\n  \n  if slogan and #slogan > 0 then\n    apiUrl = apiUrl .. \"\/\" .. slogan\n  end\n  \n  if colors or tags then\n    apiUrl = apiUrl .. \"?\"\n    if colors then\n      apiUrl = apiUrl .. \"color=\" .. colors\n    end\n    if colors and tags then\n      apiUrl = apiUrl .. \"&\"\n    end\n    if tags then\n      apiUrl = apiUrl .. \"tag=\" .. tags\n    end\n  end\n  \n  Http.get(apiUrl, nil, function(code, content)\n    if code == 200 then\n      local json = require \"cjson\"\n      local response = json.decode(content)\n      callback(response, nil)\n    else\n      callback(nil, \"Error generating logo. Status code: \" .. code)\n    end\n  end)\nend\n\n-- Function to download logo\nfunction downloadLogo(logoUrl)\n  local request = DownloadManager.Request(Uri.parse(logoUrl))\n  request.setTitle(\"Generated Logo\")\n  request.setDescription(\"Downloading generated logo\")\n  request.setNotificationVisibility(DownloadManager.Request.VISIBILITY_VISIBLE_NOTIFY_COMPLETED)\n  request.setDestinationInExternalPublicDir(Environment.DIRECTORY_PICTURES, \"Logo_\" .. os.time() .. \".png\")\n  \n  local downloadManager = this.getSystemService(Context.DOWNLOAD_SERVICE)\n  downloadManager.enqueue(request)\n  \n  Toast.makeText(this, \"Download started\", Toast.LENGTH_SHORT).show()\nend\n\n-- Function to create input row with EditText and Paste button\nfunction createInputRow(hint)\n  local rowLayout = LinearLayout(this)\n  rowLayout.setOrientation(LinearLayout.HORIZONTAL)\n  \n  local editText = EditText(this)\n  editText.setHint(hint)\n  editText.setLayoutParams(LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT, 1))\n  rowLayout.addView(editText)\n  \n  local pasteButton = Button(this)\n  pasteButton.setText(\"Paste\")\n  pasteButton.setLayoutParams(LinearLayout.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT))\n  pasteButton.setOnClickListener{\n    onClick = function()\n      local clipboard = this.getSystemService(Context.CLIPBOARD_SERVICE)\n      local clip = clipboard.getPrimaryClip()\n      if clip and clip.getItemCount() > 0 then\n        editText.setText(clip.getItemAt(0).getText())\n      end\n    end\n  }\n  rowLayout.addView(pasteButton)\n  \n  return rowLayout, editText\nend\n\n-- Create main layout\nlocal layout = LinearLayout(this)\nlayout.setOrientation(LinearLayout.VERTICAL)\nlayout.setPadding(16, 16, 16, 16)\nlayout.setBackgroundColor(0xFFFFFFFF)  -- White background\n\nlocal businessDescriptionRow, businessDescriptionInput = createInputRow(\"Enter business description\")\nlayout.addView(businessDescriptionRow)\n\nlocal businessNameRow, businessNameInput = createInputRow(\"Enter business name\")\nlayout.addView(businessNameRow)\n\nlocal sloganRow, sloganInput = createInputRow(\"Enter slogan (optional)\")\nlayout.addView(sloganRow)\n\nlocal colorsRow, colorsInput = createInputRow(\"Enter colors (Grayscale,Blue,Purple,Pink,Red,Orange,Green)\")\nlayout.addView(colorsRow)\n\nlocal tagsRow, tagsInput = createInputRow(\"Enter tags (Abstract,Mascot,Emblem,Corporate,Wordmark,Vintage,Classic)\")\nlayout.addView(tagsRow)\n\nlocal generateButton = Button(this)\ngenerateButton.setText(\"Generate Logo\")\nlayout.addView(generateButton)\n\nlocal resultText = TextView(this)\nlayout.addView(resultText)\n\nlocal downloadButton = Button(this)\ndownloadButton.setText(\"Download Logos\")\ndownloadButton.setVisibility(View.GONE)\nlayout.addView(downloadButton)\n\nlocal cancelButton = Button(this)\ncancelButton.setText(\"Cancel\")\nlayout.addView(cancelButton)\n\nlocal infoText = TextView(this)\ninfoText.setText(\"Join our channel for more content: https:\/\/t.me\/jcftbs\")\ninfoText.setGravity(Gravity.CENTER)\nlayout.addView(infoText)\n\nlocal creditText = TextView(this)\ncreditText.setText(\"Credit: GlitchyAPI\")\ncreditText.setGravity(Gravity.CENTER)\nlayout.addView(creditText)\n\n-- Create a floating window\nlocal windowManager = this.getSystemService(Context.WINDOW_SERVICE)\nlocal params = WindowManager.LayoutParams()\nparams.type = WindowManager.LayoutParams.TYPE_APPLICATION_OVERLAY\nparams.flags = WindowManager.LayoutParams.FLAG_NOT_FOCUSABLE\nparams.width = WindowManager.LayoutParams.WRAP_CONTENT\nparams.height = WindowManager.LayoutParams.WRAP_CONTENT\nparams.format = PixelFormat.TRANSLUCENT\n\nwindowManager.addView(layout, params)\n\n-- Function to update result text\nfunction updateResultText(result)\n  resultText.setText(result)\nend\n\n-- Set up generate button\ngenerateButton.setOnClickListener{\n  onClick = function()\n    local businessDescription = businessDescriptionInput.getText().toString()\n    local businessName = businessNameInput.getText().toString()\n    local slogan = sloganInput.getText().toString()\n    local colors = colorsInput.getText().toString()\n    local tags = tagsInput.getText().toString()\n    \n    if businessDescription and #businessDescription > 0 and businessName and #businessName > 0 then\n      updateResultText(\"Generating logo...\")\n      downloadButton.setVisibility(View.GONE)\n      \n      generateLogo(businessDescription, businessName, slogan, colors, tags, function(response, error)\n        if error then\n          updateResultText(\"Error: \" .. error)\n        else\n          if response.logo1 and response.logo2 and response.logo3 then\n            updateResultText(\"Logos generated successfully!\\n\\nLogo 1: \" .. response.logo1 .. \"\\n\\nLogo 2: \" .. response.logo2 .. \"\\n\\nLogo 3: \" .. response.logo3)\n            downloadButton.setVisibility(View.VISIBLE)\n            downloadButton.setTag(response.logo1 .. \"|\" .. response.logo2 .. \"|\" .. response.logo3)\n          else\n            updateResultText(\"Invalid API response\")\n          end\n        end\n      end)\n    else\n      updateResultText(\"Please enter business description and name\")\n    end\n  end\n}\n\n-- Set up download button\ndownloadButton.setOnClickListener{\n  onClick = function()\n    local logoUrls = downloadButton.getTag()\n    if logoUrls then\n      for url in logoUrls:gmatch(\"[^|]+\") do\n        downloadLogo(url)\n      end\n    else\n      Toast.makeText(this, \"No logo URLs available\", Toast.LENGTH_SHORT).show()\n    end\n  end\n}\n\n-- Set up cancel button\ncancelButton.setOnClickListener{\n  onClick = function()\n    windowManager.removeView(layout)\n  end\n}"},{"code":"require \"import\"\nimport \"android.widget.*\"\nimport \"android.app.AlertDialog\"\nimport \"android.content.DialogInterface\"\nimport \"android.os.Vibrator\"\nimport \"android.speech.tts.TextToSpeech\"\nimport \"java.util.Locale\"\nimport \"android.view.Gravity\"\nimport \"android.view.View\"\nimport \"android.view.ViewGroup\"\nimport \"android.widget.LinearLayout\"\nimport \"android.view.MotionEvent\"\nimport \"android.os.Handler\"\nimport \"android.os.Looper\"\n\nlocal activity = activity\nlocal tts\nlocal vibrator\nlocal startTime\nlocal elapsedTime\nlocal points = 0\nlocal level = 1\nlocal coins = 1\nlocal isRunning = false\nlocal isBonusActive = false\nlocal isStarted = false  -- Flag to check if the game has started\nlocal scoreText\nlocal levelText\nlocal coinsText\nlocal scoreUpdateHandler\nlocal scoreUpdateRunnable\nlocal bonusHandler\nlocal bonusRunnable\nlocal coinsPerLevel = 5  -- Number of points needed to earn a coin\nlocal treasureBoxReward = 100  -- Number of coins given in the treasure box\nlocal lessonLevel = 5  -- Level at which lessons are given\nlocal bonusInterval = 60000  -- 1 minute in milliseconds\nlocal bonusAmount = 10  -- Bonus amount in coins\n\nfunction onCreate(savedInstanceState)\n    activity.setTitle(\"Coin Craze\")  -- Updated game title\n\n    local layout = LinearLayout(activity)\n    layout.setOrientation(LinearLayout.VERTICAL)\n    layout.setGravity(Gravity.CENTER)\n\n    levelText = TextView(activity)\n    levelText.setTextSize(24)\n    layout.addView(levelText)\n\n    scoreText = TextView(activity)\n    scoreText.setTextSize(24)\n    layout.addView(scoreText)\n\n    coinsText = TextView(activity)\n    coinsText.setTextSize(24)\n    layout.addView(coinsText)\n\n    local startButton = Button(activity)\n    startButton.setText(\"Start\")\n    startButton.setOnClickListener{\n        onClick = function(v)\n            startGame()\n        end\n    }\n    layout.addView(startButton)\n\n    local earnButton = Button(activity)\n    earnButton.setText(\"Earn Points\")\n    earnButton.setOnTouchListener{\n        onTouch = function(v, event)\n            if event.getAction() == MotionEvent.ACTION_DOWN then\n                startEarning()\n            elseif event.getAction() == MotionEvent.ACTION_UP then\n                stopGame()\n            end\n            return true\n        end\n    }\n    layout.addView(earnButton)\n\n    local recoverButton = Button(activity)\n    recoverButton.setText(\"Recover Progress\")\n    recoverButton.setOnClickListener{\n        onClick = function(v)\n            recoverProgress()\n        end\n    }\n    layout.addView(recoverButton)\n\n    tts = TextToSpeech(activity, TextToSpeech.OnInitListener({\n        onInit = function(status)\n            if status == TextToSpeech.SUCCESS then\n                tts.setLanguage(Locale.US)\n            else\n                speak(\"Text-to-speech initialization failed.\")\n            end\n        end\n    }))\n\n    vibrator = activity.getSystemService(\"vibrator\")\n    if vibrator == nil then\n        vibrator = activity.getSystemService(Context.VIBRATOR_SERVICE)\n    end\n\n    scoreUpdateHandler = Handler(Looper.getMainLooper())\n    scoreUpdateRunnable = Runnable({\n        run = function()\n            if isRunning and not isBonusActive then\n                points = points + 1\n                scoreText.setText(\"Score: \" .. points)\n\n                -- Update level based on points\n                level = math.floor(points \/ coinsPerLevel) + 1\n                updateLevelText()\n\n                -- Update coins based on points\n                local coinsEarned = math.floor(points \/ coinsPerLevel)\n                if coinsEarned > coins then\n                    coins = coinsEarned\n                    updateCoinsText()\n                    speakRepeatedly(\"Congratulations! You've earned \" .. coins .. \" coins.\")\n                end\n\n                -- Check if the user has reached a new level milestone\n                if level % 10 == 0 then\n                    giveTreasureBox()\n                    awardMedal()\n                end\n\n                -- Check if the user has reached a lesson level\n                if level % lessonLevel == 0 then\n                    giveLesson()\n                end\n\n                scoreUpdateHandler.postDelayed(scoreUpdateRunnable, 1000)\n            end\n        end\n    })\n\n    bonusHandler = Handler(Looper.getMainLooper())\n    bonusRunnable = Runnable({\n        run = function()\n            if isRunning and not isBonusActive then\n                isBonusActive = true\n                coins = coins + bonusAmount\n                updateCoinsText()\n                speakRepeatedly(\"You've earned a bonus of \" .. bonusAmount .. \" coins. Your total coins are now \" .. coins .. \".\")\n                bonusHandler.postDelayed(bonusRunnable, bonusInterval)\n                -- Ensure bonus does not stop game\n                isBonusActive = false\n            end\n        end\n    })\n\n    activity.setContentView(layout)\n    updateLevelText()\n    updateCoinsText()\nend\n\nfunction startGame()\n    points = 0\n    level = 1\n    coins = 1  -- Default coin value is set to 1\n    updateLevelText()\n    updateCoinsText()\n    scoreText.setText(\"Score: \" .. points)\n    speak(\"Game started. Press and hold the earn button to score points.\")\n    isStarted = true  -- Set the flag to true when the game starts\nend\n\nfunction startEarning()\n    if isStarted and not isRunning then  -- Check if game is started\n        isRunning = true\n        startTime = System.currentTimeMillis()\n        scoreUpdateHandler.post(scoreUpdateRunnable)\n        bonusHandler.postDelayed(bonusRunnable, bonusInterval)\n        vibrate(100)\n    end\nend\n\nfunction stopGame()\n    if isRunning then\n        isRunning = false\n        elapsedTime = System.currentTimeMillis() - startTime\n        speak(\"Game over. Your final score is \" .. points .. \" points.\")\n        vibrate(500)\n        scoreUpdateHandler.removeCallbacks(scoreUpdateRunnable)\n        bonusHandler.removeCallbacks(bonusRunnable)\n        resetGame()\n    end\nend\n\nfunction resetGame()\n    points = 0\n    level = 1\n    updateLevelText()\n    scoreText.setText(\"Score: \" .. points)\n    isBonusActive = false\n    isStarted = false  -- Reset the game start flag\nend\n\nfunction recoverProgress()\n    if coins >= 5 then\n        coins = coins - 5\n        points = points + 10\n        updateCoinsText()\n        scoreText.setText(\"Score: \" .. points)\n        speak(\"Progress recovered. Your score is now \" .. points .. \" points.\")\n        vibrate(200)\n    else\n        speak(\"Not enough coins to recover progress. You need 5 coins.\")\n    end\nend\n\nfunction updateLevelText()\n    levelText.setText(\"Level: \" .. level)\nend\n\nfunction updateCoinsText()\n    coinsText.setText(\"Coins: \" .. coins)\nend\n\nfunction giveTreasureBox()\n    if level % 10 == 0 then\n        coins = coins + treasureBoxReward\n        updateCoinsText()\n        speakRepeatedly(\"Congratulations! You've received a treasure box with \" .. treasureBoxReward .. \" coins. Total coins: \" .. coins)\n    end\nend\n\nfunction awardMedal()\n    speak(\"Congratulations! You've reached level \" .. level .. \". You have earned a medal.\")\nend\n\nfunction giveLesson()\n    speak(\"Congratulations! You've reached level \" .. level .. \". Here's a lesson to help you recover progress.\")\nend\n\nfunction speak(text)\n    tts.speak(text, TextToSpeech.QUEUE_FLUSH, nil)\nend\n\nfunction speakRepeatedly(text)\n    -- Speak the message repeatedly until it is heard\n    local repeatCount = 3  -- Number of times to repeat\n    for i = 1, repeatCount do\n        tts.speak(text, TextToSpeech.QUEUE_ADD, nil)\n    end\nend\n\nfunction vibrate(duration)\n    if vibrator ~= nil then\n        vibrator.vibrate(duration)\n    else\n        speak(\"Vibration is not available on this device.\")\n    end\nend"},{"code":"require \"import\"\nimport \"android.widget.*\"\nimport \"android.view.*\"\nimport \"cjson\"\n\nmessages = {}\nlocal articleGenerated = false\nlocal originalTopic = \"\"\n\nfunction urlEncode(text)\n  text = tostring(text)\n  text = text:gsub(\"\\n\", \"\\r\\n\")\n  text = text:gsub(\"([^%w %-%_%.%~])\", function(c)\n    return string.format(\"%%%02X\", string.byte(c))\n  end)\n  text = text:gsub(\" \", \"+\")\n  return text\nend\n\nfunction cleanText(text)\n  local cleanedText = cjson.decode(text) \n  if cleanedText then\n    cleanedText = cleanedText.answer\n    cleanedText = cleanedText:gsub(\"[#:*]\", \"\") -- Remove #, :, and *\n    cleanedText = cleanedText:gsub(\"%s+\", \" \") -- Replace multiple spaces with a single space\n    cleanedText = cleanedText:gsub(\"^%s*(.-)%s*$\", \"%1\") -- Trim leading and trailing spaces\n    \n    -- Format into paragraphs\n    local paragraphs = {}\n    for paragraph in cleanedText:gmatch(\"([^\\n]+)\") do\n      table.insert(paragraphs, paragraph:match(\"^%s*(.-)%s*$\"))\n    end\n    cleanedText = table.concat(paragraphs, \"\\n\\n\")\n    \n    return cleanedText\n  else\n    return \"Text is not available.\"\n  end\nend\n\nfunction addMessage(container, title, message)\n  local fullMessage = title .. \"\\n\\n\" .. message\n  local messageLayout = {\n    TextView;\n    text = fullMessage;\n    textSize = \"16sp\";\n    textColor = \"#ffffff\";\n    padding = \"10dp\";\n  }\n  local textView = TextView(service)\n  container.addView(textView)\n  textView.setText(fullMessage)\n  table.insert(messages, message)\n  textView.setTextColor(0xFFFFFFFF)\n  textView.setTextSize(16)\n  if message == \"ChatGPT is generating an article...\" then\n    container.removeViewAt(container.getChildCount() - 1)\n  end\nend\n\nfunction generateArticle(topic, isRewrite)\n  local encodedTopic = urlEncode(topic)\n  local prompt\n  if isRewrite then\n    prompt = \"Rewrite the article about the following topic. Use a different approach or perspective, but keep the original title: \"\n  else\n    prompt = \"Please write an article about the following topic: \"\n  end\n  local url = \"https:\/\/chatgpt.hideme.eu.org\/?ask=\" .. urlEncode(prompt .. topic .. \". Remember that every article must have a Slug. Remember that you can change the Slug as you please. And you'll need to bring the slug when you're done writing the article or before you write it. Please check the article for any spelling and grammatical errors and correct them. Please ensure that the article is factually accurate. Please do not refer to other news sources in the article.\")\n  \n  addMessage(messagesContainer, \"Topic:\", topic) \n  service.postSpeak(200, \"ChatGPT is generating an article...\") \n  Http.get(url, function(status, data)\n    if status == 200 then\n      local cleanedData = cleanText(data)\n      addMessage(messagesContainer, \"Article:\", cleanedData) \n      service.postSpeak(200, cleanedData)\n      topicInput.setText(\"\")\n      articleGenerated = true\n      if not isRewrite then\n        originalTopic = topic\n      end\n    else\n      local errorMessage = \"An error occurred while processing the request.\" \n      addMessage(messagesContainer, \"Error:\", errorMessage) \n      service.postSpeak(200, errorMessage)\n    end\n  end)\nend\n\nlayout = {\n  LinearLayout;\n  orientation = \"vertical\";\n  layout_width=\"match_parent\";\n  layout_height=\"match_parent\";\n  backgroundColor = \"#000000\";\n  { \n    RelativeLayout;\n    layout_width=\"match_parent\";\n    layout_height=\"match_parent\";\n    backgroundColor = \"#000000\";\n\n    {\n      EditText;\n      hint = \"Topic\"; \n      id = \"topicInput\";\n      InputType = \"textMultiLine\";\n      layout_width=\"match_parent\";\n      layout_height=\"wrap_content\";\n      layout_alignParentLeft=true;      \n      layout_marginRight=\"100dp\";   \n    };    \n    {\n      Button;\n      text = \">\";\n      contentDescription = \"Generate Article\"; \n      id = \"generateButton\";\n      textColor = \"#000000\";\n      backgroundColor = \"#ffffff\";\n      layout_width=\"40sp\";\n      layout_height=\"wrap_content\";\n      layout_alignParentRight=true;\n      onClick = function(view)\n        local topicText = topicInput.text\n        if topicText == \"\" then\n           service.postSpeak(200, \"Please enter a topic first.\") \n          return\n        end\n        generateArticle(topicText, false)\n      end;\n    };\n    {\n      Button;\n      text = \"↻\";\n      contentDescription = \"Rewrite Article\"; \n      id = \"rewriteButton\";\n      textColor = \"#000000\";\n      backgroundColor = \"#ffffff\";\n      layout_width=\"40sp\";\n      layout_height=\"wrap_content\";\n      layout_toLeftOf=\"generateButton\";\n      layout_marginRight=\"10dp\";\n      onClick = function(view)\n        if not articleGenerated then\n          service.postSpeak(200, \"Please generate an article first.\") \n          return\n        end\n        generateArticle(originalTopic, true)\n      end;\n    };\n  };\n  {\n    Button;\n    text = \"×\"; \n    backgroundColor = \"#000000\";   \n    contentDescription = \"Exit\"; \n    layout_width = \"match_parent\";\n    layout_height = \"wrap_content\";\n    onClick = function()\n      dlg.dismiss()\n    end;\n  };\n  {\n    ScrollView;\n    layout_width = \"match_parent\";\n    layout_height = \"match_parent\";\n    {\n      LinearLayout;\n      id = \"messagesContainer\";\n      orientation = \"vertical\";\n      layout_width = \"match_parent\";\n      layout_height = \"wrap_content\";\n      padding = \"10dp\";\n    };\n  };\n  {\n    TextView;\n    text = \"Join our channel for more content: https:\/\/t.me\/jcftbs\";\n    layout_width = \"match_parent\";\n    layout_height = \"wrap_content\";\n    padding = \"10dp\";\n    gravity = \"center\";\n    textColor = \"#ffffff\";\n  };\n}\n\ndlg = LuaDialog()\ndlg.setTitle(\"Article Generator\") \ndlg.setView(loadlayout(layout))\ndlg.show()"},{"code":"require \"import\"\nimport \"android.widget.*\"\nimport \"com.androlua.*\"\nimport \"android.view.View\"\nimport \"android.os.Environment\"\nimport \"java.io.File\"\nimport \"java.net.URL\"\nimport \"java.io.FileOutputStream\"\nimport \"android.app.DownloadManager\"\nimport \"android.net.Uri\"\nimport \"android.content.Context\"\nimport \"android.text.Html\"\nimport \"cjson\"\n\n-- YOUR HUGGING FACE ACCESS TOKEN\nlocal API_TOKEN = \"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\"  -- **Replace with your actual token!**\n\n-- Function to interact with Hugging Face Inference API\nfunction query(data, callback)\n  local apiUrl = \"https:\/\/api-inference.huggingface.co\/models\/HuggingFaceH4\/zephyr-7b-beta\"\n\n  local requestBody = cjson.encode(data)\n\n  local headers = {}\n  headers[\"Authorization\"] = \"Bearer \" .. API_TOKEN\n  headers[\"Content-Type\"] = \"application\/json\"\n\n  Http.post(apiUrl, requestBody, headers, function(code, content)\n    if code == 200 then\n      local success, result = pcall(cjson.decode, content)\n      if success then\n        callback(cjson.encode(result), nil) -- Return the full JSON response\n      else\n        callback(nil, \"Error decoding JSON response: \" .. content)\n      end\n    else\n      callback(nil, \"Error querying Hugging Face API. Status code: \" .. code .. \", Content: \" .. content)\n    end\n  end)\nend\n\n-- Create main layout\nlayout = {\n  LinearLayout,\n  orientation = \"vertical\",\n  layout_width = \"fill\",\n  layout_height = \"fill\",\n  padding = \"16dp\",\n  {\n    EditText,\n    id = \"inputText\",\n    hint = \"Enter your input for zephyr-7b-beta\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n  },\n  {\n    Button,\n    id = \"queryButton\",\n    text = \"Query Hugging Face API\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n  },\n  {\n    TextView,\n    id = \"resultText\",\n    text = \"\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n  },\n  { -- Added LinearLayout for Exit button and Credit text\n    LinearLayout,\n    orientation = \"vertical\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    {\n      Button,\n      id = \"exitButton\",\n      text = \"Exit\",\n      layout_width = \"wrap_content\",\n      layout_height = \"wrap_content\",\n    },\n    {\n      TextView,\n      text = \"Join our channel for more content:\\nhttps:\/\/t.me\/jcftbs\",\n      layout_width = \"fill\",\n      layout_height = \"wrap_content\",\n      gravity = \"center\",\n      padding = \"5dp\",\n    }\n  }\n}\n\n-- Create dialog\ndlg = LuaDialog(this)\ndlg.setTitle(\"zephyr-7b-beta\")\ndlg.setView(loadlayout(layout))\n\n-- Function to update result text (MODIFIED to show only AI response)\nfunction updateResultText(result)\n  local success, decoded_result = pcall(cjson.decode, result)\n  if success then\n    -- Assuming the AI response is always in the first element of the array\n    if decoded_result[1] and decoded_result[1].generated_text then\n      resultText.text = decoded_result[1].generated_text\n    else\n      resultText.text = \"Error: Unexpected JSON format\"\n    end\n  else\n    resultText.text = \"Error decoding JSON: \" .. result\n  end\nend\n\n-- Set up query button\nqueryButton.onClick = function()\n  local input = inputText.text\n\n  if input and #input > 0 then\n    updateResultText(\"Querying Hugging Face API...\")\n\n    query({ inputs = input }, function(result, error)\n      if error then\n        updateResultText(\"Error: \" .. error)\n      else\n        updateResultText(result) -- Display the AI response only\n      end\n    end)\n  else\n    updateResultText(\"Please enter input for zephyr-7b-beta\")\n  end\nend\n\n-- Set up exit button\nexitButton.onClick = function()\n  dlg.dismiss()\nend\n\n-- Show dialog\ndlg.show()"},{"code":"require \"import\"\nimport \"android.widget.*\"\nimport \"com.androlua.*\"\nimport \"android.view.View\"\nimport \"android.os.Environment\"\nimport \"java.io.File\"\nimport \"java.net.URL\"\nimport \"java.io.FileOutputStream\"\nimport \"android.app.DownloadManager\"\nimport \"android.net.Uri\"\nimport \"android.content.Context\"\nimport \"android.text.Html\"\nimport \"cjson\"\nimport \"android.media.MediaPlayer\"\n\n-- YOUR HUGGING FACE ACCESS TOKEN\nlocal API_TOKEN = \"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\"  -- **Replace with your actual token!**\n\n-- Global variable for MediaPlayer\nlocal mediaPlayer = nil\n\n-- Function to get a unique filename with date and time stamp\nfunction getUniqueFilename(baseFilename)\n  local now = os.date(\"*t\")\n  local timestamp = string.format(\"%04d%02d%02d_%02d%02d%02d\", now.year, now.month, now.day, now.hour, now.min, now.sec)\n  return Environment.getExternalStorageDirectory().toString() .. \"\/\" .. baseFilename .. \"_\" .. timestamp .. \".mp3\"\nend\n\n-- Function to save audio data to a file\nfunction saveAudioToFile(audioData, filePath)\n  local file = io.open(filePath, \"wb\")\n  if file then\n    file:write(audioData)\n    file:close()\n    return true\n  else\n    return false, \"Error saving file.\"\n  end\nend\n\n-- Function to query the Hugging Face API\nfunction query(data, callback)\n  local apiUrl = \"https:\/\/api-inference.huggingface.co\/models\/facebook\/musicgen-small\"\n\n  local requestBody = cjson.encode(data)\n\n  local headers = {}\n  headers[\"Authorization\"] = \"Bearer \" .. API_TOKEN\n  headers[\"Content-Type\"] = \"application\/json\"\n\n  Http.post(apiUrl, requestBody, headers, function(code, content)\n    if code == 200 then\n      local filePath = getUniqueFilename(\"generated_music\") -- Use the function to get filename with timestamp\n      local success, errorMessage = saveAudioToFile(content, filePath)\n      if success then\n        callback(\"File saved: \" .. filePath, nil)\n      else\n        callback(nil, errorMessage)\n      end\n    else\n      callback(nil, \"Error querying Hugging Face API. Status code: \" .. code .. \", Content: \" .. content)\n    end\n  end)\nend\n\n-- Create main layout\nlayout = {\n  LinearLayout,\n  orientation = \"vertical\",\n  layout_width = \"fill\",\n  layout_height = \"fill\",\n  padding = \"16dp\",\n  {\n    EditText,\n    id = \"inputText\",\n    hint = \"Enter your input for AI music generator\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n  },\n  {\n    Button,\n    id = \"queryButton\",\n    text = \"Query Hugging Face API\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n  },\n  {\n    TextView,\n    id = \"resultText\",\n    text = \"\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n  },\n  { -- Added LinearLayout for Play\/Pause and Exit buttons\n    LinearLayout,\n    orientation = \"horizontal\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    {\n      Button,\n      id = \"playButton\",\n      text = \"Play\",\n      layout_width = \"0dp\",\n      layout_weight = \"1\",\n      layout_height = \"wrap_content\",\n      enabled = false, -- Initially disabled\n    },\n    {\n      Button,\n      id = \"pauseButton\",\n      text = \"Pause\",\n      layout_width = \"0dp\",\n      layout_weight = \"1\",\n      layout_height = \"wrap_content\",\n      enabled = false, -- Initially disabled\n    }\n  },\n  {\n    Button,\n    id = \"exitButton\",\n    text = \"Exit\",\n    layout_width = \"wrap_content\",\n    layout_height = \"wrap_content\",\n  },\n  {\n    TextView,\n    text = \"Join our channel for more content:\\nhttps:\/\/t.me\/jcftbs\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    gravity = \"center\",\n    padding = \"5dp\",\n  }\n}\n\n-- Create dialog\ndlg = LuaDialog(this)\ndlg.setTitle(\"AI music generator\")\ndlg.setView(loadlayout(layout))\n\n-- Function to update result text\nfunction updateResultText(result)\n  if result then\n    resultText.text = result\n  else\n    resultText.text = \"Error: Could not generate music.\"\n  end\nend\n\n-- Set up query button\nqueryButton.onClick = function()\n  local input = inputText.text\n\n  if input and #input > 0 then\n    updateResultText(\"Querying Hugging Face API...\")\n    playButton.enabled = false -- Disable play button while querying\n    pauseButton.enabled = false\n\n    query({ inputs = input }, function(result, error)\n      if error then\n        updateResultText(\"Error: \" .. error)\n      else\n        updateResultText(result)\n        playButton.enabled = true -- Enable play button after successful query\n        pauseButton.enabled = false\n      end\n    end)\n  else\n    updateResultText(\"Please enter input for AI music generator\")\n  end\nend\n\n-- Set up play button\nplayButton.onClick = function()\n  -- Reset the mediaPlayer each time the play button is clicked\n  if mediaPlayer then\n    mediaPlayer.release()\n    mediaPlayer = nil\n  end\n\n  local filePath = resultText.text:match(\"File saved: (.*)\") -- Extract file path from result text\n  if filePath then\n    mediaPlayer = MediaPlayer.create(this, Uri.parse(filePath))\n    mediaPlayer.setOnCompletionListener(function()\n      playButton.enabled = true\n      pauseButton.enabled = false\n      -- Release the mediaPlayer after playback completes\n      mediaPlayer.release()\n      mediaPlayer = nil\n    end)\n    mediaPlayer.start()\n    playButton.enabled = false\n    pauseButton.enabled = true\n  else\n    updateResultText(\"Error: Could not find generated music file.\")\n  end\nend\n\n-- Set up pause button\npauseButton.onClick = function()\n  if mediaPlayer and mediaPlayer.isPlaying() then\n    mediaPlayer.pause()\n    playButton.enabled = true\n    pauseButton.enabled = false\n  end\nend\n\n-- Set up exit button\nexitButton.onClick = function()\n  if mediaPlayer then\n    mediaPlayer.release()\n    mediaPlayer = nil\n  end\n  dlg.dismiss()\nend\n\n-- Show dialog\ndlg.show()"},{"code":"require \"import\"\nimport \"android.widget.*\"\nimport \"com.androlua.*\"\nimport \"android.view.View\"\nimport \"cjson\"\n\n-- YOUR AIML API KEY\nlocal API_KEY = \"5af5b3b484644f06b670cc338fdb9dc8\"\n\n-- Function to interact with AIML API\nfunction query(data, callback)\n  local apiUrl = \"https:\/\/api.aimlapi.com\/v1\/chat\/completions\"\n\n  local requestBody = cjson.encode(data)\n\n  local headers = {}\n  headers[\"Authorization\"] = \"Bearer \" .. API_KEY\n  headers[\"Content-Type\"] = \"application\/json\"\n\n  Http.post(apiUrl, requestBody, headers, function(code, content)\n    if code == 200 or code == 201 then\n      local success, result = pcall(cjson.decode, content)\n      if success then\n        callback(cjson.encode(result), nil)\n      else\n        callback(nil, \"Error decoding JSON response: \" .. content)\n      end\n    else\n      callback(nil, \"Error querying AIML API. Status code: \" .. code .. \", Content: \" .. content)\n    end\n  end)\nend\n\n-- Create main layout\nlayout = {\n  LinearLayout,\n  orientation = \"vertical\",\n  layout_width = \"fill\",\n  layout_height = \"fill\",\n  padding = \"16dp\",\n  { -- Exit button (now the first button)\n    Button,\n    id = \"exitButton\",\n    text = \"Exit\",\n    layout_width = \"wrap_content\",\n    layout_height = \"wrap_content\",\n  },\n  {\n    EditText,\n    id = \"inputText\",\n    hint = \"Enter your message\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n  },\n  {\n    Button,\n    id = \"queryButton\",\n    text = \"Send Message\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n  },\n  {\n    TextView,\n    id = \"resultText\",\n    text = \"\", -- Initially empty\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n  },\n  { -- Channel credit\n    TextView,\n    text = \"Join our channel for more content:\\nhttps:\/\/t.me\/jcftbs\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    gravity = \"center\",\n    padding = \"5dp\",\n  }\n}\n\n-- Create dialog\ndlg = LuaDialog(this)\ndlg.setTitle(\"Meta-Llama-3.1-405B-Instruct-Turbo\")\ndlg.setView(loadlayout(layout))\n\n-- Function to update result text\nfunction updateResultText(result)\n  local success, decoded_result = pcall(cjson.decode, result)\n  if success then\n    if decoded_result.choices and decoded_result.choices[1] and decoded_result.choices[1].message and decoded_result.choices[1].message.content then\n      resultText.text = decoded_result.choices[1].message.content\n    else\n      -- Don't show error message, keep the \"AI is typing...\" text\n    end\n  else\n    -- Don't show error message, keep the \"AI is typing...\" text\n  end\nend\n\n-- Set up query button\nqueryButton.onClick = function()\n  local input = inputText.text\n\n  if input and #input > 0 then\n    resultText.text = \"AI is typing...\" -- Set text directly\n\n    query({ \n      model = \"meta-llama\/Meta-Llama-3.1-405B-Instruct-Turbo\",\n      messages = {{ role = \"user\", content = input }} \n    }, function(result, error)\n      if error then\n        -- Don't update resultText on error, keep \"AI is typing...\"\n      else\n        updateResultText(result)\n      end\n    end)\n  else\n    resultText.text = \"Please enter a message\"\n  end\nend\n\n-- Set up exit button\nexitButton.onClick = function()\n  dlg.dismiss()\nend\n\n-- Show dialog\ndlg.show()"},{"code":"require \"import\"\nimport \"android.widget.*\"\nimport \"com.androlua.*\"\nimport \"android.view.View\"\nimport \"android.content.ClipboardManager\"\nimport \"android.content.Context\"\nimport \"android.util.Xml\"\nimport \"java.io.ByteArrayInputStream\"\nimport \"android.content.ClipData\" \n\n-- Function to fetch and parse RSS feed\nfunction fetchRssFeed(rssUrl, callback)\n  local entries = {}\n\n  Http.get(rssUrl, nil, function(code, content)\n    if code == 200 then\n      local inputStream = ByteArrayInputStream(String(content).getBytes())\n\n      local parser = Xml.newPullParser()\n      parser.setInput(inputStream, \"UTF-8\") \n\n      local eventType = parser.getEventType()\n      local currentTag = \"\"\n      local currentEntry = {}\n\n      -- Cambia 'XmlPullParser' a 'parser' en las siguientes líneas\n      while eventType ~= parser.END_DOCUMENT do\n        if eventType == parser.START_TAG then\n          currentTag = parser.getName()\n          if currentTag == \"item\" then\n            currentEntry = {}\n          end\n        elseif eventType == parser.TEXT then\n          if currentTag == \"title\" then\n            currentEntry.title = parser.getText()\n          elseif currentTag == \"link\" then\n            currentEntry.link = parser.getText()\n          end\n        elseif eventType == parser.END_TAG then\n          if parser.getName() == \"item\" then\n            table.insert(entries, currentEntry)\n          end\n          currentTag = \"\"\n        end\n        eventType = parser.next()\n      end\n\n      inputStream.close() \n\n      callback(entries, nil)\n    else\n      callback(nil, \"Error fetching RSS feed. Status code: \" .. code)\n    end\n  end)\nend\n\n-- Function to copy text to clipboard\nfunction copyToClipboard(text)\n  local clipboard = this.getSystemService(Context.CLIPBOARD_SERVICE)\n  local clip = ClipData.newPlainText(\"Link\", text)\n  clipboard.setPrimaryClip(clip)\n  Toast.makeText(this, \"Link copied to clipboard: \\n\" .. text, Toast.LENGTH_LONG).show() -- Display copied link\nend\n\n-- Create main layout\nlayout = {\n  LinearLayout,\n  orientation = \"vertical\",\n  layout_width = \"fill\",\n  layout_height = \"fill\",\n  padding = \"16dp\",\n  {\n    TextView,\n    text = \"Apps and Games for Blind People\",\n    textSize = \"18sp\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    gravity = \"center\",\n    layout_marginBottom = \"16dp\",\n  },\n  {\n    ListView,\n    id = \"appList\",\n    layout_width = \"fill\",\n    layout_height = \"0dp\",\n    layout_weight = \"1\",\n  },\n  {\n    Button,\n    id = \"exitButton\",\n    text = \"Exit\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n  },\n  {\n    TextView,\n    text = \"Created by: JCFTBS\\nJoin our channel for more content.\\nhttps:\/\/t.me\/jcftbs\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n    gravity = \"center\",\n  }\n}\n\n-- Create dialog\ndlg = LuaDialog(this)\ndlg.setTitle(\"Accessible Apps and Games\")\ndlg.setView(loadlayout(layout))\n\n-- Fetch and populate app list\nfetchRssFeed(\"https:\/\/ddt.one\/en\/rss.xml\", function(entries, error)\n  if error then\n    print(\"Error:\", error)\n    return\n  end\n\n  local appItems = {}\n  for _, entry in ipairs(entries) do\n    table.insert(appItems, entry.title .. \"\\n\" .. entry.link) -- Combine title and link\n  end\n\n  appList.adapter = ArrayAdapter(this, android.R.layout.simple_list_item_1, appItems)\n\n  appList.onItemClick = function(_, _, position, _)\n    local selectedEntry = entries[position + 1]\n    copyToClipboard(selectedEntry.link) \n  end\nend)\n\n-- Set up exit button\nexitButton.onClick = function()\n  dlg.dismiss()\nend\n\n-- Show dialog\ndlg.show()"},{"code":"require \"import\"\nimport \"android.widget.*\"\nimport \"com.androlua.*\"\nimport \"android.net.Uri\"\nimport \"android.app.DownloadManager\"\nimport \"android.content.Context\"\nimport \"android.os.Environment\"\nimport \"android.view.View\"\n\n-- Credit: This code was modified by the assistant based on the human's request\n-- Original API by @Itz_Ashlynn\n\n-- Function to get video info\nfunction getVideoInfo(url, quality, callback)\n  local apiUrl = \"https:\/\/any-down.darkhacker7301.workers.dev\/?url=\" .. url\n  if quality then\n    apiUrl = apiUrl .. \"&vQuality=\" .. quality\n  end\n  \n  Http.get(apiUrl, nil, function(code, content)\n    if code ~= 200 then\n      callback(nil, \"Error fetching video info\")\n    else\n      local json = require(\"cjson\")\n      local videoInfo = json.decode(content)\n      callback(videoInfo)\n    end\n  end)\nend\n\n-- Function to start download using DownloadManager\nfunction startDownload(url, title)\n  local request = DownloadManager.Request(Uri.parse(url))\n  request.setTitle(title or \"Video Download\")\n  request.setNotificationVisibility(DownloadManager.Request.VISIBILITY_VISIBLE_NOTIFY_COMPLETED)\n  request.setDestinationInExternalPublicDir(Environment.DIRECTORY_DOWNLOADS, title or \"video.mp4\")\n  \n  local downloadManager = this.getSystemService(Context.DOWNLOAD_SERVICE)\n  downloadManager.enqueue(request)\nend\n\n-- Create main layout\nlayout = {\n  LinearLayout,\n  orientation = \"vertical\",\n  layout_width = \"fill\",\n  layout_height = \"fill\",\n  {\n    EditText,\n    id = \"urlInput\",\n    hint = \"Enter video URL\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n  },\n  {\n    EditText,\n    id = \"qualityInput\",\n    hint = \"Enter quality (optional, for YouTube)\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n  },\n  {\n    LinearLayout,\n    orientation = \"horizontal\",\n    layout_width = \"fill\",\n    {\n      Button,\n      id = \"getInfoButton\",\n      text = \"Get Video Info\",\n      layout_width = \"wrap_content\",\n      layout_height = \"wrap_content\",\n    },\n    {\n      Button,\n      id = \"cancelButton\",\n      text = \"Cancel\",\n      layout_width = \"wrap_content\",\n      layout_height = \"wrap_content\",\n    }\n  },\n  {\n    TextView,\n    id = \"statusText\",\n    text = \"\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n  },\n  {\n    Button,\n    id = \"downloadButton\",\n    text = \"Download Video\",\n    layout_width = \"wrap_content\",\n    layout_height = \"wrap_content\",\n    visibility = View.GONE,\n  },\n  {\n    TextView,\n    text = \"Supports YouTube, Instagram, Facebook, TikTok, Pinterest, Reddit, and more\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n  }\n}\n\n-- Create dialog\ndlg = LuaDialog(this)\ndlg.setTitle(\"Multi-Platform Video Downloader\")\ndlg.setView(loadlayout(layout))\n\n-- Function to update status\nfunction updateStatus(message)\n  statusText.text = message\nend\n\n-- Function to show\/hide download button\nfunction toggleDownloadButton(show)\n  downloadButton.visibility = show and View.VISIBLE or View.GONE\nend\n\n-- Variable to store video info\nvideoInfoGlobal = nil\n\n-- Set up get info button\ngetInfoButton.onClick = function()\n  local url = urlInput.text\n  local quality = qualityInput.text\n  if url and #url > 0 then\n    updateStatus(\"Fetching video info...\")\n    toggleDownloadButton(false)\n    \n    getVideoInfo(url, quality, function(videoInfo, error)\n      if error then\n        updateStatus(\"Error: \" .. error)\n      else\n        if videoInfo and videoInfo.fileUrl then\n          videoInfoGlobal = videoInfo\n          updateStatus(\"Video info received successfully.\")\n          updateStatus(statusText.text .. \"\\nVideo URL: \" .. videoInfo.fileUrl)\n          if videoInfo.title and videoInfo.title ~= \"Unknown Title\" then\n            updateStatus(statusText.text .. \"\\nTitle: \" .. videoInfo.title)\n          end\n          if videoInfo.fileSize and videoInfo.fileSize ~= \"NaN undefined\" then\n            updateStatus(statusText.text .. \"\\nSize: \" .. videoInfo.fileSize)\n          end\n          toggleDownloadButton(true)\n        else\n          updateStatus(\"Error: Unable to extract video URL\")\n        end\n      end\n    end)\n  else\n    updateStatus(\"Please enter a valid video URL\")\n  end\nend\n\n-- Set up download button\ndownloadButton.onClick = function()\n  if videoInfoGlobal and videoInfoGlobal.fileUrl then\n    local title = videoInfoGlobal.title ~= \"Unknown Title\" and videoInfoGlobal.title or nil\n    startDownload(videoInfoGlobal.fileUrl, title)\n    updateStatus(\"Download started. Check notification for progress.\")\n  else\n    updateStatus(\"Error: No video info available. Please get video info first.\")\n  end\nend\n\n-- Set up cancel button\ncancelButton.onClick = function()\n  dlg.dismiss()\nend\n\n-- Show dialog\ndlg.show()"},{"code":"require \"import\"\nimport \"android.widget.*\"\nimport \"com.androlua.*\"\nimport \"android.view.View\"\nimport \"org.json.JSONObject\"\n\n-- Variable to store the current chat ID\ncurrentChatId = nil\n\n-- Function to make API request\nfunction makeChatRequest(apiKey, modelId, prompt, maxTokens, chatId, callback)\n  local url = \"https:\/\/api.abhibhai.com\/api\/v6\/llm\/chat\"\n  local headers = {[\"Content-Type\"] = \"application\/json\"}\n  \n  local payload = {\n    api_key = apiKey,\n    model_id = modelId,\n    prompt = prompt,\n    max_new_tokens = maxTokens,\n    do_sample = true,\n    temperature = 0.3,\n    top_k = 50,\n    top_p = 0.95,\n    no_repeat_ngram_size = 5,\n    temp = false\n  }\n  \n  if chatId and type(chatId) == \"string\" and #chatId > 0 then\n    payload.chat_id = chatId\n  end\n  \n  local json = require(\"cjson\")\n  local jsonPayload = json.encode(payload)\n  \n  Http.post(url, jsonPayload, headers, function(code, content)\n    if code ~= 200 then\n      callback(nil, \"Error making API request: \" .. code)\n    else\n      callback(content)\n    end\n  end)\nend\n\n-- Function to parse API response\nfunction parseApiResponse(response)\n  local json = require(\"cjson\")\n  local responseObj = json.decode(response)\n  \n  local aiMessage = responseObj.message or \"No message found\"\n  local chatUrl = \"\"\n  if responseObj.output and #responseObj.output > 0 then\n    chatUrl = responseObj.output[1]\n  end\n  local chatId = responseObj.chat_id or \"\"\n  \n  return aiMessage, chatUrl, chatId\nend\n\n-- Create main layout\nlayout = {\n  LinearLayout,\n  orientation = \"vertical\",\n  layout_width = \"fill\",\n  layout_height = \"fill\",\n  {\n    EditText,\n    id = \"apiKeyInput\",\n    hint = \"Enter your API key\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n  },\n  {\n    EditText,\n    id = \"modelIdInput\",\n    hint = \"Enter model ID (e.g., zephyr-7b-beta)\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n  },\n  {\n    EditText,\n    id = \"promptInput\",\n    hint = \"Enter your prompt\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n    lines = 3,\n  },\n  {\n    EditText,\n    id = \"maxTokensInput\",\n    hint = \"Max tokens (1-1024, default 128)\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n    inputType = \"number\",\n  },\n  {\n    LinearLayout,\n    orientation = \"horizontal\",\n    layout_width = \"fill\",\n    {\n      Button,\n      id = \"sendButton\",\n      text = \"Send Request\",\n      layout_width = \"wrap_content\",\n      layout_height = \"wrap_content\",\n    },\n    {\n      Button,\n      id = \"newChatButton\",\n      text = \"New Chat\",\n      layout_width = \"wrap_content\",\n      layout_height = \"wrap_content\",\n    },\n    {\n      Button,\n      id = \"cancelButton\",\n      text = \"Cancel\",\n      layout_width = \"wrap_content\",\n      layout_height = \"wrap_content\",\n    }\n  },\n  {\n    ScrollView,\n    layout_width = \"fill\",\n    layout_height = \"fill\",\n    {\n      LinearLayout,\n      orientation = \"vertical\",\n      layout_width = \"fill\",\n      layout_height = \"wrap_content\",\n      {\n        TextView,\n        id = \"chatIdText\",\n        text = \"Chat ID: None\",\n        layout_width = \"fill\",\n        layout_height = \"wrap_content\",\n        padding = \"10dp\",\n      },\n      {\n        TextView,\n        id = \"aiResponseText\",\n        text = \"\",\n        layout_width = \"fill\",\n        layout_height = \"wrap_content\",\n        padding = \"10dp\",\n      },\n      {\n        TextView,\n        id = \"chatUrlText\",\n        text = \"\",\n        layout_width = \"fill\",\n        layout_height = \"wrap_content\",\n        padding = \"10dp\",\n      }\n    }\n  },\n  {\n    TextView,\n    text = \"Powered by https:\/\/t.me\/jcftbs\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n  }\n}\n\n-- Create dialog\ndlg = LuaDialog(this)\ndlg.setTitle(\"Chat open Tool\")\ndlg.setView(loadlayout(layout))\n\n-- Function to update response\nfunction updateResponse(aiMessage, chatUrl, chatId)\n  aiResponseText.text = \"AI Response:\\n\" .. aiMessage\n  chatUrlText.text = \"Chat URL:\\n\" .. chatUrl\n  if chatId and type(chatId) == \"string\" and #chatId > 0 then\n    currentChatId = chatId\n    chatIdText.text = \"Chat ID: \" .. chatId\n  end\nend\n\n-- Set up send button\nsendButton.onClick = function()\n  local apiKey = apiKeyInput.text\n  local modelId = modelIdInput.text\n  local prompt = promptInput.text\n  local maxTokens = tonumber(maxTokensInput.text) or 128\n  \n  if apiKey and modelId and prompt and #apiKey > 0 and #modelId > 0 and #prompt > 0 then\n    if maxTokens < 1 or maxTokens > 1024 then\n      aiResponseText.text = \"Max tokens should be between 1 and 1024\"\n      chatUrlText.text = \"\"\n      return\n    end\n    \n    aiResponseText.text = \"Sending request...\"\n    chatUrlText.text = \"\"\n    \n    makeChatRequest(apiKey, modelId, prompt, maxTokens, currentChatId, function(response, error)\n      if error then\n        aiResponseText.text = \"Error: \" .. error\n        chatUrlText.text = \"\"\n      else\n        local aiMessage, chatUrl, chatId = parseApiResponse(response)\n        updateResponse(aiMessage, chatUrl, chatId)\n      end\n    end)\n  else\n    aiResponseText.text = \"Please fill in all required fields\"\n    chatUrlText.text = \"\"\n  end\nend\n\n-- Set up new chat button\nnewChatButton.onClick = function()\n  currentChatId = nil\n  chatIdText.text = \"Chat ID: None\"\n  aiResponseText.text = \"\"\n  chatUrlText.text = \"\"\n  promptInput.text = \"\"\nend\n\n-- Set up cancel button\ncancelButton.onClick = function()\n  dlg.dismiss()\nend\n\n-- Show dialog\ndlg.show()"},{"code":"require \"import\"\nimport \"android.widget.*\"\nimport \"com.androlua.*\"\nimport \"android.view.View\"\nimport \"android.os.Environment\"\nimport \"java.io.File\"\nimport \"java.net.URL\"\nimport \"java.io.FileOutputStream\"\nimport \"android.app.DownloadManager\"\nimport \"android.net.Uri\"\nimport \"android.content.Context\"\nimport \"android.text.Html\"\nimport \"cjson\"\nimport \"android.graphics.drawable.BitmapDrawable\"\n\n-- YOUR HUGGING FACE ACCESS TOKEN\nlocal API_TOKEN = \"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\" -- **Replace with your actual token!**\n\n-- Function to get a unique filename with date and time stamp\nfunction getUniqueFilename(baseFilename)\n  local now = os.date(\"*t\")\n  local timestamp = string.format(\"%04d%02d%02d_%02d%02d%02d\", now.year, now.month, now.day, now.hour, now.min, now.sec)\n  local fileCounter = 1\n  local filePath = Environment.getExternalStorageDirectory().toString() .. \"\/\" .. baseFilename .. \"_\" .. timestamp .. \".png\"\n  \n  while os.rename(filePath, filePath) == false do -- Check if file exists\n    filePath = Environment.getExternalStorageDirectory().toString() .. \"\/\" .. baseFilename .. \"_\" .. timestamp .. \"_\" .. fileCounter .. \".png\"\n    fileCounter = fileCounter + 1\n  end\n\n  return filePath\nend\n\n-- Function to save image data to a file\nfunction saveImageToFile(imageData, filePath)\n  local file = io.open(filePath, \"wb\")\n  if file then\n    file:write(imageData)\n    file:close()\n    return true\n  else\n    return false, \"Error saving file.\"\n  end\nend\n\n-- Function to query the Hugging Face API\nfunction query(data, callback)\n  local apiUrl = \"https:\/\/api-inference.huggingface.co\/models\/stabilityai\/sd-turbo\"\n\n  local requestBody = cjson.encode(data)\n\n  local headers = {}\n  headers[\"Authorization\"] = \"Bearer \" .. API_TOKEN\n  headers[\"Content-Type\"] = \"application\/json\"\n\n  Http.post(apiUrl, requestBody, headers, function(code, content)\n    if code == 200 then\n      local filePath = getUniqueFilename(\"generated_image\") -- Get unique filename with timestamp\n      local success, errorMessage = saveImageToFile(content, filePath)\n      if success then\n        callback(\"File saved: \" .. filePath, nil)\n      else\n        callback(nil, errorMessage)\n      end\n    else\n      callback(nil, \"Error querying Hugging Face API. Status code: \" .. code .. \", Content: \" .. content)\n    end\n  end)\nend\n\n-- Create main layout\nlayout = {\n  LinearLayout,\n  orientation = \"vertical\",\n  layout_width = \"fill\",\n  layout_height = \"fill\",\n  padding = \"16dp\",\n  {\n    EditText,\n    id = \"inputText\",\n    hint = \"Enter your input for sd-turbo\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n  },\n  {\n    Button,\n    id = \"queryButton\",\n    text = \"GENERATE IMAGE\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n  },\n  {\n    TextView,\n    id = \"resultText\",\n    text = \"\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n  },\n  {\n    ImageView,\n    id = \"generatedImage\",\n    layout_width = \"fill\",\n    layout_height = \"300dp\", -- Adjust height as needed\n    visibility = View.GONE, -- Initially hidden\n  },\n  {\n    Button,\n    id = \"exitButton\",\n    text = \"Exit\",\n    layout_width = \"wrap_content\",\n    layout_height = \"wrap_content\",\n  },\n  {\n    TextView,\n    text = \"Join our channel for more content:\\nhttps:\/\/t.me\/jcftbs\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    gravity = \"center\",\n    padding = \"5dp\",\n  }\n}\n\n-- Create dialog\ndlg = LuaDialog(this)\ndlg.setTitle(\"sd-turbo\")\ndlg.setView(loadlayout(layout))\n\n-- Function to update result text\nfunction updateResultText(result)\n  if result then\n    resultText.text = result\n  else\n    resultText.text = \"Error: Could not generate image.\"\n  end\nend\n\n-- Set up query button\nqueryButton.onClick = function()\n  local input = inputText.text\n\n  if input and #input > 0 then\n    updateResultText(\"Creating your image...\")\n    generatedImage.visibility = View.GONE -- Hide image while querying\n\n    query({ inputs = input }, function(result, error)\n      if error then\n        updateResultText(\"Error: \" .. error)\n      else\n        updateResultText(result)\n        local filePath = result:match(\"File saved: (.*)\") -- Extract filename from result\n        generatedImage.setImageBitmap(loadbitmap(filePath))\n        generatedImage.visibility = View.VISIBLE -- Show image after successful query\n      end\n    end)\n  else\n    updateResultText(\"Please enter input for sd-turbo\")\n  end\nend\n\n-- Set up exit button\nexitButton.onClick = function()\n  dlg.dismiss()\nend\n\n-- Show dialog\ndlg.show()"},{"code":"require \"import\"\ncrypt = require \"crypt\"\njson = require \"cjson\"\nimport \"java.io.*\"\nimport \"com.androlua.*\"\nimport \"android.graphics.Bitmap\"\nimport \"java.util.Locale\"\n\n-- ImgBB API key\nlocal imgbbApiKey = '9cae14aa30d8e506d9b37f0f5e49bb42'\n\n-- ImgBB API URL\nlocal imgbbApiUrl = \"https:\/\/api.imgbb.com\/1\/upload\"\n\n-- Upload history\nlocal uploadHistory = {}\n\n-- Load upload history from file\nfunction loadHistory()\n    local file = io.open(\"\/sdcard\/img\/upload_history.json\", \"r\")\n    if file then\n        local content = file:read(\"*all\")\n        file:close()\n        local success, decodedHistory = pcall(json.decode, content)\n        if success and type(decodedHistory) == \"table\" then\n            uploadHistory = decodedHistory\n        else\n            print(\"Error: Invalid upload history file\")\n        end\n    else\n        print(\"No existing upload history found\")\n    end\nend\n\n-- Save upload history to file\nfunction saveHistory()\n    local file, errorMsg = io.open(\"\/sdcard\/img\/upload_history.json\", \"w\")\n    if file then\n        file:write(json.encode(uploadHistory))\n        file:close()\n        print(\"History saved successfully\")\n    else\n        print(\"Error saving history: \" .. (errorMsg or \"unknown error\"))\n    end\nend\n\n-- Function to get the first two characters of the language code\nfunction getLanguageCode()\n    local locale = Locale.getDefault()\n    local language = tostring(locale)\n    local langCode = string.sub(language, 1, 2)\n    return langCode\nend\n\n-- Function to upload image to ImgBB\nfunction uploadToImgbb(imagePath)\n    local file, errorMsg = io.open(imagePath, \"rb\")\n    if not file then\n        print(\"Error: Unable to open image file - \" .. (errorMsg or \"unknown error\"))\n        return\n    end\n    local imageData = file:read(\"*all\")\n    file:close()\n\n    local base64Image = crypt.base64encode(imageData)\n\n    Http.post(imgbbApiUrl .. \"?key=\" .. imgbbApiKey, {\n        image = base64Image\n    }, {}, function(status, body)\n        if status == 200 then\n            local success, result = pcall(json.decode, body)\n            if success and result.data and result.data.url then\n                print(\"Image uploaded successfully\")\n                print(\"URL: \" .. result.data.url)\n\n                -- Add to upload history\n                table.insert(uploadHistory, {\n                    url = result.data.url,\n                    time = os.date(\"%Y-%m-%d %H:%M:%S\")\n                })\n                saveHistory()\n            else\n                print(\"Error: Failed to parse response\")\n            end\n        else\n            print(\"Error uploading image: \" .. status)\n        end\n    end)\nend\n\n-- Function to display upload history\nfunction displayHistory()\n    if #uploadHistory == 0 then\n        print(\"Upload history is empty\")\n        return\n    end\n    print(\"Upload History:\")\n    for i, item in ipairs(uploadHistory) do\n        print(string.format(\"%d. %s - %s\", i, item.url, item.time))\n    end\nend\n\n-- Function to export history\nfunction exportHistory()\n    local exportPath = \"\/sdcard\/img\/upload_history_export.json\"\n    local file, errorMsg = io.open(exportPath, \"w\")\n    if file then\n        file:write(json.encode(uploadHistory))\n        file:close()\n        print(\"History exported to: \" .. exportPath)\n    else\n        print(\"Error: Unable to export history - \" .. (errorMsg or \"unknown error\"))\n    end\nend\n\n-- Function to import history\nfunction importHistory()\n    local importPath = \"\/sdcard\/img\/upload_history_export.json\"  -- Changed from upload_history_import.json\n    local file, errorMsg = io.open(importPath, \"r\")\n    if not file then\n        print(\"Error: Unable to import history - \" .. (errorMsg or \"unknown error\"))\n        return\n    end\n    \n    local content = file:read(\"*all\")\n    file:close()\n    \n    local success, importedHistory = pcall(json.decode, content)\n    if not success then\n        print(\"Error: Invalid JSON in import file\")\n        return\n    end\n    \n    if type(importedHistory) ~= \"table\" then\n        print(\"Error: Imported data is not in the correct format\")\n        return\n    end\n    \n    uploadHistory = importedHistory\n    saveHistory()\n    print(\"History imported successfully\")\nend\n\n-- Function to ensure directory exists\nfunction ensureDirectoryExists(directoryPath)\n    local dir = File(directoryPath)\n    if not dir.exists() then\n        local success = dir.mkdirs()\n        if not success then\n            print(\"Error: Unable to create directory \" .. directoryPath)\n        end\n    end\nend\n\n-- Function to generate a unique image name\nfunction generateImageName()\n    local timestamp = os.time()\n    local randomNum = math.random(1000, 9999)\n    return string.format(\"image_%d_%d.jpg\", timestamp, randomNum)\nend\n\n-- Function to capture and process image\nfunction captureAndProcessImage(focus)\n    local directoryPath = focus == 1 and \"\/sdcard\/img\/obj\" or \"\/sdcard\/img\/prints\"\n    ensureDirectoryExists(directoryPath)\n    \n    local imageName = generateImageName()\n    service.copy(imageName)\n    local imagePath = directoryPath .. \"\/\" .. imageName\n\n    local screenCaptureFunc = function(bmp)\n        local success, errorMsg = pcall(function()\n            bmp.compress(Bitmap.CompressFormat.PNG, 90, FileOutputStream(File(imagePath)))\n        end)\n        if success then\n            this.speak(\"Processing image, please wait.\")\n            task(300, function()\n                uploadToImgbb(imagePath)\n            end)\n        else\n            print(\"Error capturing screen: \" .. (errorMsg or \"unknown error\"))\n        end\n    end\n\n    if focus == 1 then\n        task(80, function()\n            this.getScreenShot(node, {onScreenCaptureDone = screenCaptureFunc})\n        end)\n    else\n        task(80, function()\n            this.getScreenShot({onScreenCaptureDone = screenCaptureFunc})\n        end)\n    end\nend\n\n-- Function to show options dialog\nfunction showOptionsDialog()\n    local t = {\n        \"Upload focused item\",\n        \"Upload entire screen\",\n        \"Display history\",\n        \"Export history\",\n        \"Import history\"\n    }\n    local dlg = LuaDialog().setItems(t).show()\n    dlg.onItemClick = function(l, v, p, i)\n        dlg.dismiss()\n        if i == 1 or i == 2 then\n            captureAndProcessImage(i)\n        elseif i == 3 then\n            displayHistory()\n        elseif i == 4 then\n            exportHistory()\n        elseif i == 5 then\n            importHistory()\n        end\n    end\nend\n\n-- Load history at script start\nloadHistory()\n\n-- Start the application\nshowOptionsDialog()"},{"code":"require \"import\"\ncrypt = require \"crypt\"\njson = require \"cjson\"\nimport \"java.io.*\"\nimport \"com.androlua.*\"\nimport \"android.graphics.Bitmap\"\nimport \"java.util.Locale\"\n\nmistral_api_url = \"https:\/\/api.mistral.ai\/v1\/chat\/completions\"\nmistral_api_key = \"b35UMUnQHfJtpgEAvoohCE9r0szDj6rm\"\ntranslation_api_url = \"https:\/\/ashlynn.serv00.net\/lang-trans.php\"\n\n-- Custom URL encoding function\nfunction urlEncode(str)\n    if str then\n        str = string.gsub(str, \"\\n\", \"\\r\\n\")\n        str = string.gsub(str, \"([^%w %-%_%.%~])\",\n            function(c)\n                return string.format(\"%%%02X\", string.byte(c))\n            end)\n        str = string.gsub(str, \" \", \"+\")\n    end\n    return str\nend\n\n-- Function to get the first two characters of the language code\nfunction getLanguageCode()\n    local locale = Locale.getDefault()\n    local language = tostring(locale)\n    local langCode = string.sub(language, 1, 2)\n    return langCode\nend\n\n-- Function to translate text\nfunction translateText(text, targetLang)\n    local encodedText = urlEncode(text)\n    local url = string.format(\"%s\/?text=%s&source=en&target=%s\", translation_api_url, encodedText, targetLang)\n    \n    Http.get(url, function(code, body)\n        if code == 200 then\n            local response = json.decode(body)\n            if response.status then\n                print(response.translated_text)\n                this.speak(response.translated_text)\n            else\n                print(\"Translation failed\")\n                this.speak(\"Translation failed\")\n            end\n        else\n            print(\"Error in translation request: \" .. code)\n            this.speak(\"Error in translation request\")\n        end\n    end)\nend\n\n-- Function to process the image using Mistral AI API\nfunction processImage(base64Image)\n    local headers = {\n        [\"Content-Type\"] = \"application\/json\",\n        [\"Authorization\"] = \"Bearer \" .. mistral_api_key\n    }\n    \n    local prompt = [[\n    Analyze this image and provide a brief description. Focus on the following aspects:\n    1. Main subject or focus of the image\n    2. Colors and overall mood\n    3. Any notable actions or events occurring\n    4. Background or setting, if relevant\n    Please keep the description concise, around 2-3 sentences.\n    ]]\n\n    local requestBody = json.encode({\n        model = \"pixtral-12b-2409\",\n        messages = {\n            {\n                role = \"system\",\n                content = \"You are an AI assistant specialized in analyzing images and providing brief, accurate descriptions.\"\n            },\n            {\n                role = \"user\",\n                content = {\n                    {\n                        type = \"text\",\n                        text = prompt\n                    },\n                    {\n                        type = \"image_url\",\n                        image_url = \"data:image\/jpeg;base64,\" .. base64Image\n                    }\n                }\n            }\n        },\n        max_tokens = 1024\n    })\n\n    Http.post(mistral_api_url, requestBody, headers, function(status, body)\n        if status == 200 then\n            local response = json.decode(body)\n            if response.choices and response.choices[1] and response.choices[1].message then\n                local content = response.choices[1].message.content\n                -- Translate the response\n                translateText(content, getLanguageCode())\n            else\n                print(\"Unexpected response format\")\n                this.speak(\"Unexpected response format\")\n            end\n        else\n            print(\"Error in API request: \" .. status)\n            this.speak(\"Error in API request\")\n        end\n    end)\nend\n\n-- Function to ensure directory exists\nfunction ensureDirectoryExists(directoryPath)\n    local dir = File(directoryPath)\n    if not dir.exists() then\n        dir.mkdirs()\n    end\nend\n\n-- Function to generate a unique image name\nfunction generateImageName()\n    local timestamp = os.time()\n    local randomNum = math.random(1000, 9999)\n    return string.format(\"image_%d_%d.jpg\", timestamp, randomNum)\nend\n\n-- Function to capture and process the image via API\nfunction captureAndProcessImage(focus)\n    local directoryPath = focus == 1 and \"\/sdcard\/bemyeyes\/obj\" or \"\/sdcard\/bemyeyes\/prints\"\n    \n    ensureDirectoryExists(directoryPath)\n    \n    local imageName = generateImageName()\n    service.copy(imageName)\n    local imagePath = directoryPath .. \"\/\" .. imageName\n\n    local screenCaptureFunc = function(bmp)\n        bmp.compress(Bitmap.CompressFormat.JPEG, 90, FileOutputStream(File(imagePath)))\n        this.speak(\"Processing image, please wait.\")\n        task(300, function()\n            local fl = io.open(imagePath, \"rb\")\n            local tfl = fl:read(\"*a\")\n            fl:close()\n            local base64Image = crypt.base64encode(tfl)\n            processImage(base64Image)\n        end)\n    end\n\n    if focus == 1 then\n        task(80, function()\n            this.getScreenShot(node, {onScreenCaptureDone = screenCaptureFunc})\n        end)\n    else\n        task(80, function()\n            this.getScreenShot({onScreenCaptureDone = screenCaptureFunc})\n        end)\n    end\nend\n\n-- Function to display the choice dialog\nfunction showOptionsDialog()\n    local t = {\"Recognize focused item\", \"Recognize entire screen\"}\n    local dlg = LuaDialog().setItems(t).show()\n    dlg.onItemClick = function(l, v, p, i)\n        dlg.dismiss()\n        captureAndProcessImage(i)\n    end\nend\n\n-- Call the dialog to allow user choice\nshowOptionsDialog()"},{"code":"require \"import\"\nimport \"android.widget.*\"\nimport \"com.androlua.*\"\nimport \"android.view.View\"\nimport \"cjson\"\n\n-- YOUR AIML API KEY\nlocal API_KEY = \"8592807e509c4447926794ef4d0b999c\"\n\n-- Function to interact with AIML API\nfunction query(data, callback)\n  local apiUrl = \"https:\/\/api.aimlapi.com\/v1\/chat\/completions\"\n\n  local requestBody = cjson.encode(data)\n\n  local headers = {}\n  headers[\"Authorization\"] = \"Bearer \" .. API_KEY\n  headers[\"Content-Type\"] = \"application\/json\"\n\n  Http.post(apiUrl, requestBody, headers, function(code, content)\n    if code == 200 or code == 201 then\n      local success, result = pcall(cjson.decode, content)\n      if success then\n        callback(cjson.encode(result), nil)\n      else\n        callback(nil, \"Error decoding JSON response: \" .. content)\n      end\n    else\n      callback(nil, \"Error querying AIML API. Status code: \" .. code .. \", Content: \" .. content)\n    end\n  end)\nend\n\n-- Create main layout\nlayout = {\n  LinearLayout,\n  orientation = \"vertical\",\n  layout_width = \"fill\",\n  layout_height = \"fill\",\n  padding = \"16dp\",\n  { -- Exit button (now the first button)\n    Button,\n    id = \"exitButton\",\n    text = \"Exit\",\n    layout_width = \"wrap_content\",\n    layout_height = \"wrap_content\",\n  },\n  {\n    EditText,\n    id = \"inputText\",\n    hint = \"Enter your message\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n  },\n  {\n    Button,\n    id = \"queryButton\",\n    text = \"Send Message\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n  },\n  {\n    TextView,\n    id = \"resultText\",\n    text = \"\", -- Initially empty\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n  },\n  { -- Channel credit\n    TextView,\n    text = \"Join our channel for more content:\\nhttps:\/\/t.me\/jcftbs\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    gravity = \"center\",\n    padding = \"5dp\",\n  }\n}\n\n-- Create dialog\ndlg = LuaDialog(this)\ndlg.setTitle(\"o1-mini v0.1\")\ndlg.setView(loadlayout(layout))\n\n-- Function to update result text\nfunction updateResultText(result)\n  local success, decoded_result = pcall(cjson.decode, result)\n  if success then\n    if decoded_result.choices and decoded_result.choices[1] and decoded_result.choices[1].message and decoded_result.choices[1].message.content then\n      resultText.text = decoded_result.choices[1].message.content\n    else\n      -- Don't show error message, keep the \"AI is typing...\" text\n    end\n  else\n    -- Don't show error message, keep the \"AI is typing...\" text\n  end\nend\n\n-- Set up query button\nqueryButton.onClick = function()\n  local input = inputText.text\n\n  if input and #input > 0 then\n    resultText.text = \"AI is typing...\" -- Set text directly\n\n    query({ \n      model = \"o1-mini\",\n      messages = {{ role = \"user\", content = input }} \n    }, function(result, error)\n      if error then\n        -- Don't update resultText on error, keep \"AI is typing...\"\n      else\n        updateResultText(result)\n      end\n    end)\n  else\n    resultText.text = \"Please enter a message\"\n  end\nend\n\n-- Set up exit button\nexitButton.onClick = function()\n  dlg.dismiss()\nend\n\n-- Show dialog\ndlg.show()"},{"code":"require \"import\"\nimport \"android.widget.*\"\nimport \"com.androlua.*\"\nimport \"android.view.View\"\nimport \"android.os.Environment\"\nimport \"java.io.File\"\nimport \"java.net.URL\"\nimport \"java.io.FileOutputStream\"\nimport \"android.app.DownloadManager\"\nimport \"android.net.Uri\"\nimport \"android.content.Context\"\nimport \"android.text.Html\"\nimport \"cjson\"\nimport \"android.content.ClipboardManager\"\nimport \"android.content.ClipData\"\nimport \"android.text.InputType\"\nimport \"android.view.inputmethod.EditorInfo\"\n\n-- YOUR OPENROUTER API KEY\nlocal OPENROUTER_API_KEY = \"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\"\n\n-- Function to interact with OpenRouter AI\nfunction chatWithOpenRouterAI(question, imageUrl, callback)\n  local apiUrl = \"https:\/\/openrouter.ai\/api\/v1\/chat\/completions\"\n\n  local messages = {\n    {\n      role = \"user\",\n      content = {}\n    }\n  }\n\n  if question and #question > 0 then\n    table.insert(messages[1].content, {type = \"text\", text = question})\n  end\n\n  if imageUrl and #imageUrl > 0 then\n    table.insert(messages[1].content, {\n      type = \"image_url\",\n      image_url = {\n        url = imageUrl\n      }\n    })\n  end\n\n  local requestBody = {\n    model = \"meta-llama\/llama-3.2-11b-vision-instruct:free\",\n    messages = messages\n  }\n  local jsonData = cjson.encode(requestBody)\n\n  local headers = {}\n  headers[\"Content-Type\"] = \"application\/json\"\n  headers[\"Authorization\"] = \"Bearer \" .. OPENROUTER_API_KEY\n\n  Http.post(apiUrl, jsonData, headers, function(code, content)\n    if code == 200 then\n      local success, result = pcall(cjson.decode, content)\n      if success and result.choices and result.choices[1] and result.choices[1].message and result.choices[1].message.content then\n        callback(result.choices[1].message.content, nil)\n      else\n        callback(nil, \"Invalid response format\")\n      end\n    else\n      callback(nil, \"Error chatting with OpenRouter AI. Status code: \" .. code)\n    end\n  end)\nend\n\n-- Create main layout\nlayout = {\n  LinearLayout,\n  orientation = \"vertical\",\n  layout_width = \"fill\",\n  layout_height = \"fill\",\n  padding = \"16dp\",\n  {\n    LinearLayout,\n    orientation = \"horizontal\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    {\n      Button,\n      id = \"exitButton\",\n      text = \"Exit\",\n      layout_width = \"wrap_content\",\n      layout_height = \"wrap_content\",\n    },\n    {\n      TextView,\n      text = \"Join our channel for more content:\\nhttps:\/\/t.me\/jcftbs\",\n      layout_width = \"fill\",\n      layout_height = \"wrap_content\",\n      gravity = \"center\",\n      padding = \"5dp\",\n    }\n  },\n  {\n    ScrollView,\n    layout_width = \"fill\",\n    layout_height = \"0dp\",\n    layout_weight = 1,\n    {\n      LinearLayout,\n      id = \"chatHistoryLayout\",\n      orientation = \"vertical\",\n      layout_width = \"fill\",\n      layout_height = \"wrap_content\",\n    }\n  },\n  {\n    LinearLayout,\n    orientation = \"vertical\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    {\n      EditText,\n      id = \"inputText\",\n      hint = \"Enter your message for Llama 3 Vision AI\",\n      layout_width = \"fill\",\n      layout_height = \"wrap_content\",\n      padding = \"10dp\",\n      gravity = \"top|left\",\n      inputType = InputType.TYPE_CLASS_TEXT | InputType.TYPE_TEXT_FLAG_MULTI_LINE,\n      imeOptions = EditorInfo.IME_FLAG_NO_ENTER_ACTION,\n      minLines = 3,\n      maxLines = 10,\n    },\n    {\n      EditText,\n      id = \"imageUrlInput\",\n      hint = \"Enter image URL (optional)\",\n      layout_width = \"fill\",\n      layout_height = \"wrap_content\",\n      padding = \"10dp\",\n      singleLine = true,\n    },\n    {\n      Button,\n      id = \"chatButton\",\n      text = \"Send\",\n      layout_width = \"fill\",\n      layout_height = \"wrap_content\",\n    }\n  }\n}\n\n-- Create dialog\ndlg = LuaDialog(this)\ndlg.setTitle(\"Llama 3 Vision AI Chat\")\ndlg.setView(loadlayout(layout))\n\n-- Function to add a new message to chat history\nfunction addMessageToHistory(isUser, message, imageUrl)\n  local newMessage = {\n    TextView,\n    text = (isUser and \"You: \" or \"AI: \") .. message,\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n    textIsSelectable = true,\n  }\n  \n  newMessage.onClick = function(view)\n    copyToClipboard(view.text)\n  end\n  \n  chatHistoryLayout.addView(loadlayout(newMessage))\n\n  if isUser and imageUrl and #imageUrl > 0 then\n    local imageMessage = {\n      TextView,\n      text = \"Image URL: \" .. imageUrl,\n      layout_width = \"fill\",\n      layout_height = \"wrap_content\",\n      padding = \"10dp\",\n      textIsSelectable = true,\n    }\n    chatHistoryLayout.addView(loadlayout(imageMessage))\n  end\n  \n  -- Scroll to the bottom\n  chatHistoryLayout.post(function()\n    local scrollView = chatHistoryLayout.getParent()\n    scrollView.fullScroll(View.FOCUS_DOWN)\n  end)\nend\n\n-- Function to copy text to clipboard\nfunction copyToClipboard(text)\n  local clipboard = this.getSystemService(Context.CLIPBOARD_SERVICE)\n  local clip = ClipData.newPlainText(\"Llama 3 Vision AI Chat Message\", text)\n  clipboard.setPrimaryClip(clip)\n  Toast.makeText(this, \"Message copied to clipboard\", Toast.LENGTH_SHORT).show()\nend\n\n-- Set up chat button\nchatButton.onClick = function()\n  local question = inputText.text\n  local imageUrl = imageUrlInput.text\n\n  if (question and #question > 0) or (imageUrl and #imageUrl > 0) then\n    addMessageToHistory(true, question, imageUrl)\n    \n    chatWithOpenRouterAI(question, imageUrl, function(result, error)\n      if error then\n        addMessageToHistory(false, \"Error: \" .. error)\n      else\n        addMessageToHistory(false, result)\n      end\n      inputText.text = \"\" -- Clear input field after sending\n      imageUrlInput.text = \"\" -- Clear image URL field after sending\n    end)\n  else\n    Toast.makeText(this, \"Please enter a message or image URL for Llama 3 Vision AI\", Toast.LENGTH_SHORT).show()\n  end\nend\n\n-- Set up exit button\nexitButton.onClick = function()\n  dlg.dismiss()\nend\n\n-- Show dialog\ndlg.show()"},{"code":"require \"import\"\nimport \"android.widget.*\"\nimport \"com.androlua.*\"\nimport \"android.view.View\"\nimport \"android.os.Environment\"\nimport \"java.io.File\"\nimport \"java.net.URL\"\nimport \"java.io.FileOutputStream\"\nimport \"android.app.DownloadManager\"\nimport \"android.net.Uri\"\nimport \"android.content.Context\"\nimport \"android.text.Html\"\nimport \"cjson\"\n\n-- Game variables\nlocal playerPower = 10  -- Initial player power\nlocal playerLevel = 1   -- Initial player level\nlocal playerWeapons = {}  -- List of weapons collected by the player\nlocal progressReport = {  -- JSON structure to track progress\n  battlesFought = 0,\n  battlesWon = 0,\n  battlesLost = 0,\n  weaponsCollected = {},\n  playerLevel = 1,\n  playerPower = 10\n}\n\n-- File paths\nlocal storageDir = Environment.getExternalStorageDirectory().toString() .. \"\/MonsterFightingGame\"\nlocal progressFile = storageDir .. \"\/progress.json\"\n\n-- Ensure the storage directory exists\nlocal file = File(storageDir)\nif not file.exists() then\n  file.mkdirs()\nend\n\n-- Function to load progress from JSON file\nfunction loadProgress()\n  local file = File(progressFile)\n  if file.exists() then\n    local content = io.open(progressFile, \"r\"):read(\"*a\")\n    local success, data = pcall(cjson.decode, content)\n    if success then\n      progressReport = data\n      playerPower = progressReport.playerPower or 10  -- Default to 10 if missing\n      playerLevel = progressReport.playerLevel or 1   -- Default to 1 if missing\n      playerWeapons = progressReport.weaponsCollected or {}  -- Default to empty table if missing\n    else\n      -- If the file is corrupted, start over silently\n      progressReport = {\n        battlesFought = 0,\n        battlesWon = 0,\n        battlesLost = 0,\n        weaponsCollected = {},\n        playerLevel = 1,\n        playerPower = 10\n      }\n      saveProgress()\n    end\n  else\n    -- If no file exists, start over silently\n    saveProgress()\n  end\nend\n\n-- Function to save progress to JSON file\nfunction saveProgress()\n  progressReport.playerPower = playerPower\n  progressReport.playerLevel = playerLevel\n  progressReport.weaponsCollected = playerWeapons\n  local file = File(progressFile)\n  local content = cjson.encode(progressReport)\n  io.open(progressFile, \"w\"):write(content):close()\nend\n\n-- Monster data\nlocal monsters = {\n  \"Goblin\", \"Orc\", \"Dragon\", \"Skeleton\", \"Slime\", \"Troll\", \"Witch\", \"Zombie\", \"Giant Spider\", \"Minotaur\",\n  \"Vampire\", \"Werewolf\", \"Golem\", \"Banshee\", \"Chimera\", \"Hydra\", \"Kraken\", \"Phoenix\", \"Griffin\", \"Basilisk\",\n  \"Cyclops\", \"Manticore\", \"Wraith\", \"Specter\", \"Lich\", \"Beholder\", \"Necromancer\", \"Demon\", \"Imp\", \"Succubus\",\n  \"Leviathan\", \"Cerberus\", \"Harpy\", \"Medusa\", \"Siren\", \"Wyvern\", \"Roc\", \"Elemental\", \"Gargoyle\", \"Shade\",\n  \"Wight\", \"Ghoul\", \"Doppelganger\", \"Mummy\", \"Serpent\", \"Gorgon\", \"Kobold\", \"Ogre\", \"Ettin\", \"Frost Giant\"\n}\n\nlocal weapons = {\n  \"Sword\", \"Axe\", \"Bow\", \"Staff\", \"Dagger\", \"Hammer\", \"Spear\", \"Crossbow\", \"Wand\", \"Mace\",\n  \"Greatsword\", \"Battleaxe\", \"Longbow\", \"Quarterstaff\", \"Rapier\", \"Warhammer\", \"Halberd\", \"Scythe\", \"Trident\", \"Flail\",\n  \"Katana\", \"Scimitar\", \"Claws\", \"Chain Whip\", \"Throwing Knives\", \"Boomerang\", \"Nunchaku\", \"Shuriken\", \"Kusarigama\", \"Tonfa\",\n  \"Morning Star\", \"Lance\", \"Glaive\", \"Falchion\", \"Estoc\", \"Cutlass\", \"Sabre\", \"Claymore\", \"Bastard Sword\", \"Zweihander\",\n  \"Javelin\", \"Pike\", \"Partisan\", \"Ranseur\", \"Voulge\", \"Guisarme\", \"Billhook\", \"Fauchard\", \"Glaive-Guisarme\", \"Lucerne Hammer\"\n}\n\nlocal energyTypes = {\n  \"Fire\", \"Ice\", \"Lightning\", \"Earth\", \"Wind\", \"Water\", \"Dark\", \"Light\", \"Poison\", \"Arcane\"\n}\n\n-- Function to generate a random monster with a weapon and energy type\nfunction getRandomMonster()\n  local monster = monsters[math.random(1, #monsters)]\n  local monsterLevel = playerLevel < 100 and math.random(1, 10) or math.random(1, 1000)  -- Unlimited levels after player reaches level 100\n  local monsterPower = monsterLevel * 5  -- Monster power scales with level\n  local monsterWeapon = weapons[math.random(1, #weapons)]  -- Random weapon\n  local weaponEnergy = energyTypes[math.random(1, #energyTypes)]  -- Random energy type\n  return monster, monsterLevel, monsterPower, monsterWeapon, weaponEnergy\nend\n\n-- Function to simulate a fight\nfunction fightMonster()\n  local monster, monsterLevel, monsterPower, monsterWeapon, weaponEnergy = getRandomMonster()\n  local result = \"\"\n\n  progressReport.battlesFought = progressReport.battlesFought + 1\n\n  if playerPower > monsterPower then\n    playerPower = playerPower + math.random(1, 5)  -- Increase player power\n    playerLevel = playerLevel + 1  -- Increase player level\n    table.insert(playerWeapons, monsterWeapon .. \" (\" .. weaponEnergy .. \")\")  -- Add weapon with energy type\n    progressReport.battlesWon = progressReport.battlesWon + 1\n    result = \"You defeated the Level \" .. monsterLevel .. \" \" .. monster .. \" and obtained a \" .. weaponEnergy .. \" \" .. monsterWeapon .. \"! Power: \" .. playerPower\n  else\n    progressReport.battlesLost = progressReport.battlesLost + 1\n    result = \"You were defeated by the Level \" .. monsterLevel .. \" \" .. monster .. \"! Try again!\"\n  end\n\n  saveProgress()  -- Save progress after each battle\n  return result, monster, monsterLevel, monsterWeapon, weaponEnergy\nend\n\n-- Create main layout\nlayout = {\n  LinearLayout,\n  orientation = \"vertical\",\n  layout_width = \"fill\",\n  layout_height = \"fill\",\n  padding = \"16dp\",\n  {\n    TextView,\n    id = \"titleText\",\n    text = \"Monster Fighting Game\",\n    textSize = \"20sp\",\n    gravity = \"center\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n  },\n  {\n    TextView,\n    id = \"playerStats\",\n    text = \"Your Power: \" .. playerPower .. \" | Level: \" .. playerLevel .. \" | Weapons: \" .. #playerWeapons,\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n  },\n  {\n    Button,\n    id = \"fightButton\",\n    text = \"Fight a Monster!\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n  },\n  {\n    TextView,\n    id = \"resultText\",\n    text = \"Press the button to fight!\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    padding = \"10dp\",\n  },\n  { -- Added LinearLayout for Exit button and Credit text\n    LinearLayout,\n    orientation = \"vertical\",\n    layout_width = \"fill\",\n    layout_height = \"wrap_content\",\n    {\n      Button,\n      id = \"exitButton\",\n      text = \"Exit\",\n      layout_width = \"wrap_content\",\n      layout_height = \"wrap_content\",\n      onClick = function()\n        dlg.dismiss()\n      end,\n    },\n    {\n      TextView,\n      text = \"Join our channel for more content:\\nhttps:\/\/t.me\/Jieshuolibrary\",  -- Updated: Credit link\n      layout_width = \"fill\",\n      layout_height = \"wrap_content\",\n      gravity = \"center\",\n      padding = \"5dp\",\n    }\n  }\n}\n\n-- Create dialog\ndlg = LuaDialog(this)\ndlg.setTitle(\"Monster Fighting Game\")\ndlg.setView(loadlayout(layout))\n\n-- Load progress on startup\nloadProgress()\nplayerStats.text = \"Your Power: \" .. playerPower .. \" | Level: \" .. playerLevel .. \" | Weapons: \" .. #playerWeapons\n\n-- Set up fight button\nfightButton.onClick = function()\n  resultText.text = \"Fighting... (Your Power: \" .. playerPower .. \" | Level: \" .. playerLevel .. \")\"\n  local fightResult, monster, monsterLevel, monsterWeapon, weaponEnergy = fightMonster()\n  resultText.text = fightResult\n  playerStats.text = \"Your Power: \" .. playerPower .. \" | Level: \" .. playerLevel .. \" | Weapons: \" .. #playerWeapons\nend\n\n-- Show dialog\ndlg.show()"}]